##############################################################################
#
# Copyright (c) 2003 Zope Corporation and Contributors.
# All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
#
##############################################################################
"""Serializer exception types.

$Id: exceptions.py,v 1.2 2004/01/09 14:05:32 johanc Exp $
"""

class MappingError(Exception):
    """Object mapping exception"""

class SerializationError(MappingError):
    """Error during serialization"""

class DeserializationError(MappingError):
    """Error during deserialization"""

class StoreError(MappingError):
    """Error while storing"""

class LoadError(MappingError):
    """Error while loading"""

class NoStateFoundError(MappingError):
    """No state is there to load"""

class ConfigurationError(Exception):
    """Invalid mapper configuration"""
