##############################################################################
#
# Copyright (c) 2002 Zope Corporation and Contributors.
# All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
#
##############################################################################
"""Interfaces for apelib.sql.

$Id: interfaces.py,v 1.2 2004/01/09 14:05:33 johanc Exp $
"""

from Interface import Interface

class ISQLConnection (Interface):
    """Interface of SQL database connectors
    """

    def getQuery(table_name, column_defs, operation):
        """Returns a query for invoking the specified operation.

        The available operations depend on the query generator and the
        database.
        """

    def execute(query, fetch=0, cursor=None, **kw):
        """Executes a query.

        If fetch is true, returns all of the rows from the query.
        """

    def asBinary(data):
        """Converts a string to the database's binary type."""

