##############################################################################
#
# Copyright (c) 2002 Zope Corporation and Contributors.
# All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
#
##############################################################################
"""Default OID encoder.

$Id: oidencoder.py,v 1.2 2004/01/09 14:05:33 johanc Exp $
"""

from types import TupleType
from marshal import dumps, loads

from consts import ROOT_OID
from interfaces import IOIDEncoder


class OIDEncoder:
    """Simple OID encoder
    """

    __implements__ = IOIDEncoder

    def decode(self, oid):
        """Returns a keychain."""
        if oid == ROOT_OID:
            return ()
        keychain = loads(oid)
        assert isinstance(keychain, TupleType)
        return keychain

    def encode(self, keychain):
        """Returns an OID."""
        assert isinstance(keychain, TupleType)
        if keychain == ():
            return ROOT_OID
        return dumps(keychain)

