##############################################################################
#
# Copyright (c) 2002 Zope Corporation and Contributors.
# All Rights Reserved.
# 
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE
# 
##############################################################################
"""Module that holds the main database configuration.

$Id: MainConfiguration.py,v 1.2 2004/01/09 14:05:14 johanc Exp $
"""

import os

from DBTab import DBTab
from Exceptions import DBTabOverrideError

# Read the configuration from $INSTANCE_HOME/dbtab.conf if available,
# otherwise fall back to dbtab.conf.in.
main_fn = os.path.join(INSTANCE_HOME, 'dbtab.conf')
fallback_fn = os.path.join(os.path.dirname(__file__), 'dbtab.conf.in')

configuration = DBTab([main_fn], [fallback_fn])


if 1:
    # Patch App.CacheManager so it no longer sets database cache parameters.
    # In theory, cache parameters are better managed by a configuration file.
    from App.CacheManager import CacheManager

    def my_initialize_cache(self):
        " "
        pass

    def my_manage_cache_size(self, value, REQUEST):
        " "
        raise DBTabOverrideError(
            "Database cache settings must be managed through dbtab.conf.")

    def my_cache_size(self):
        " "
        return self._p_jar.db().getCacheSize()

    CacheManager.initialize_cache = my_initialize_cache
    CacheManager.manage_cache_size = my_manage_cache_size
    CacheManager.cache_size = my_cache_size

