# $Header: /usr/custom/cvs/public/EnergyPlusLive/lib/python/Products/EasyCore/EasyHardLink.py,v 1.3 2003/03/02 20:00:02 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#

__doc__="""EasyHardLink"""
__version__='$Revision: 1.3 $'[11:-2]


import Globals
from types import StringType

from ExtensionClass import Base
from OFS.DefaultObservable import DefaultObservable
from AccessControl import ClassSecurityInfo
from AccessControl import Permissions
from EasyObservable import EasyObservable, Event
# General Zope permissions
View = Permissions.view
AccessContentsInformation = Permissions.access_contents_information

import os
DEBUG_OBSERVABLE = os.environ.has_key('DEBUG_OBSERVABLE')




class EasyHardLink(EasyObservable):
    """
    """

    security = ClassSecurityInfo()

    _observers = {}

    def __init__(self):
        self._observers = {}

    security.declarePrivate('createLink')
    def createLink( self, path):
        self.registerObserver('onBeforeDelete', path)

    security.declarePrivate('verifyLink')
    def verifyLink( self, path ):
        self.unregisterObserver('onBeforeDelete', path )

    security.declarePrivate('registerBeforeDelete')
    def registerBeforeDelete( self, path):
        self.registerObserver('onBeforeDelete', path)

    security.declarePrivate('unregisterBeforeDelete')
    def unregisterBeforeDelete( self, path ):
        self.unregisterObserver('onBeforeDelete', path )

    security.declarePrivate('registerAfterAdd')
    def registerAfterAdd( self, path):
        self.registerObserver('onAfterAdd', path)

    security.declarePrivate('unregisterAfterAdd')
    def unregisterAfterAdd( self, path ):
        self.unregisterObserver('onAfterAdd', path)

    def manage_afterAdd(self, item, container):
        pass
        #self.notify(MasterCopyAdded.event_channel, MasterCopyAdded(self.getPhysicalPath()))

    def manage_beforeDelete(self, item, container):
        pass
        #self.notify(MasterCopyDeleted.event_channel, MasterCopyDeleted())

    def manage_afterClone(self, item):
        pass
        #self.notify(MasterCopyDeleted.event_channel, MasterCopyDeleted())



Globals.InitializeClass(EasyHardLink)


