# $Header: /usr/custom/cvs/public/EnergyPlusLive/lib/python/Products/EasyCore/EasyTypeRegistry.py,v 1.3 2003/10/12 17:56:11 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#


__doc__="""EasyTypeRegistry mixin class"""
__version__='$Revision: 1.3 $'[11:-2]


import Globals

from Products.EasyCore import MLOG_TAB


class EasyMetaTypeInformation:

    def __init__(self, instance_class):
        self.__instance_class=instance_class
        self.meta_type=instance_class.meta_type

    def isWorkflowable(self):
        return getattr(self.__instance_class, '_workflowable', 0)


class EasyTypeRegistrySingleton:

    def __init__(self):
        self.__registry={}

    def registerType(self, type_info):
        self.__registry[type_info.meta_type]=type_info


    def getWorkflowableTypes(self):
        wflowable=[]
        for meta_type, t_info in self.__registry.items():
            if t_info.isWorkflowable():
                wflowable.append(meta_type)
        return wflowable

    def getEasyEditableMetaTypes(self):
        return self.__registry.keys()


EasyTypeRegistry=EasyTypeRegistrySingleton()
