# $Header: /usr/custom/cvs/public/EnergyPlusLive/lib/python/Products/EasyCore/EasyXMLSupport.py,v 1.3 2003/04/14 12:34:11 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

__doc__="""EasyXMLSupport -- XML interface for access to external and
internal User Interfaces (for instance EasyEditor)."""
__version__='$Revision: 1.3 $'[11:-2]


import Globals
from Globals import HTML
from string import strip
from types import StringType
from OFS.Traversable import Traversable
from Acquisition import aq_base, aq_parent, aq_inner
from AccessControl import ClassSecurityInfo, getSecurityManager
from Products.EasyCore.EasyCorePermissions  import AccessContentsInformation
from Products.EasyCore.VirtualPath import VirtualPathBase
from Products.EasyCore.VirtualPathHelpers import path2url
from DocumentTemplate.html_quote import html_quote
from Utils.Utils import calcPaths


_marker=[]

NEWLINE="\n"

navigatable_classes = {
                         'EasyDocument':0
                       , 'EasyRoot':0
                       , 'EasyImage':0
                       , 'EasyFile':0
                       , 'EasyContactForm':0
                       , 'EasyNewsItem':0
                       , 'EasyFolder':0
                    }

def registerNavigatableClass( meta_type):
    count=navigatable_classes.get(meta_type,0)
    navigatable_classes[meta_type] = count+1

