
import re
from types import StringType
import string

from xml.dom import Node

from Products.ParsedXML.DOM.Traversal import NodeFilter, TreeWalker
from DOMUtils import *


#CompNode
class CompNodeController:
    def __init__(self, label=''):
        self.label=label

class CompNode:

    __is_comp__=1

    def __init__(self, node, controller):
        self.node=node
        self.node.CompNode=self
        self.controller=controller

    def __cmp__(self, snode):
        return cmp(self.repr(), snode.repr())

    def __hash__(self):
        return hash(self.repr())

    def repr(self):
        node=self.node
        if node.nodeType==Node.TEXT_NODE:
            return node.nodeType, node.nodeName, node.nodeValue, renderText(node)
        elif node.nodeType==Node.ELEMENT_NODE:
            return node.nodeType, node.nodeName, renderAttributes(node), renderText(node)
        else:
            return node.nodeType, node.nodeName, node.nodeValue, renderText(node)

    def xml(self):
        node=self.node
        if node.nodeType==Node.TEXT_NODE:
            return node.nodeValue
        elif node.nodeType==Node.ELEMENT_NODE:
            return "<%s%s>" % (node.nodeName,renderAttributes(node))
        else:
            return "%s, %s, %s" % (node.nodeName, node.nodeValue, node.nodeType)


def SequentiateSimple(dom):
    controller=CompNodeController("Sequentiate")
    seq=[]
    append=seq.append
    counter=0
    walker = TreeWalker(dom.documentElement, NodeFilter.SHOW_ALL, None, 1)
    while 1:
        #if isBlock(walker.currentNode):
        if isBlock(walker.currentNode) and walker.currentNode.nodeName.upper() not in ('HTML','BODY'):
            node=walker.currentNode
            node.index=counter
            cnode=CompNode(walker.currentNode, controller)
            cnode.index=counter
            append(cnode)
            counter=counter+1
        next = walker.nextNode()
        if next is None: break
    return seq


