# $Header: /usr/custom/cvs/public/EnergyPlusLive/lib/python/Products/EasyEditor/EasyDialogSupport.py,v 1.10 2003/06/16 06:57:28 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#
__doc__="""DialogSupport Object

$Colliberty: DialogSupport.py,v 1.8 2001/09/29 14:48:00 johanc Exp $"""
__version__='$Revision: 1.10 $'[11:-2]


import Globals
from Globals import DTMLFile
from AccessControl import getSecurityManager
from AccessControl import ClassSecurityInfo
from Products.EasyCore import EasyCorePermissions
from ExtensionClass import Base
from App.ProductContext import ProductContext
from Acquisition import aq_base, aq_inner, aq_chain
from zLOG import LOG

class DialogSupport(Base):

    security = ClassSecurityInfo()

    security.declareProtected(EasyCorePermissions.ViewManagementScreens, 'manage_dialog_style_css')
    manage_dialog_style_css = DTMLFile('Dialogs/dtml/manage_dialog_style.css', globals())

    security.declareProtected(EasyCorePermissions.ViewManagementScreens, 'manage_link_browser')
    manage_link_browser = DTMLFile('Dialogs/dtml/manage_link_browser', globals())

    security.declareProtected(EasyCorePermissions.ViewManagementScreens, 'manage_image_browser')
    manage_image_browser = DTMLFile('Dialogs/dtml/manage_image_browser', globals())

    #Uploading files and images should be protected by
    #another permission, and disabled if the user lacks the permission
    #It should also take into account where the user is viewing at the moment
    #and the users permissions in that particular context.

    security.declareProtected(EasyCorePermissions.ViewManagementScreens, 'manage_upload_form')
    manage_upload_form = DTMLFile('Dialogs/dtml/manage_upload_form', globals())

    security.declareProtected(EasyCorePermissions.ViewManagementScreens, 'manage_dialog_do_upload')
    def manage_dialog_do_upload(self, REQUEST=None):
        """\
        Handle uploaded files for manage_dialogs.
        """
        try:
            path=REQUEST['path']
            id=REQUEST['id']
            file=REQUEST['file']
            title=REQUEST['title']
            category=REQUEST.get('category',[])
            subject=REQUEST.get('subject', '')
            description=REQUEST.get('description', '')
            language=REQUEST.get('language',[])
            parentObj=self.restrictedTraverse(self.virtualURLToPhysicalPath(path))
            uploaded_file_id = parentObj.manage_addProduct['EasyFile'].manage_addEasyFile(id, file, title, category=category, subject=subject, description=description, language=language)
            manage_tabs_message='File %s has been uploaded.' % uploaded_file_id
        except:
            uploaded_file_id=''
            manage_tabs_message='Upload failed...'

        if REQUEST is not None:
            return self.manage_upload_form(self, REQUEST
                            , uploaded_file_id=uploaded_file_id
                            , manage_tabs_message=manage_tabs_message
                            )


Globals.InitializeClass(DialogSupport)


