# $Header: /usr/custom/cvs/public/EnergyPlusLive/lib/python/Products/EasyEditor/Features/Alignment.py,v 1.4 2003/09/25 06:49:35 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#

__doc__="""Alignment

$Colliberty: Alignment.py,v 0.0.1 2001/09/01 10:39:00 johanc Exp $"""
__version__='$Revision: 1.4 $'[11:-2]


import Globals
from Globals import HTML, DTMLFile
from string import join,split
from Features import FeatureBase, FEATUREADDPERMISSION
from Products.EasyEditor.EasyEditorClient.EasyEditorConstants import *
from AccessControl import ClassSecurityInfo
from Products.EasyCore import EasyCorePermissions


class Left(FeatureBase):
    """Left Feature"""

    meta_type = 'Left'
    __plugin_kind__ = 'HTML'

    elementid = 'LeftButton'
    command = DECMD_JUSTIFYLEFT
    accesskey = ''
    actionHandler = 'setJustifyLeft'
    updateAppearenceHandler = UH_STANDARDBUTTONHANDLER
    usesLatched = 1
    feature_type = UI_BUTTON

    # Control arguments for Button Placement
    button_group = "Alignments"
    button_group_order = 0


    def renderjsButton(self,client=None,REQUEST=None):
        return  HTML("""
            <BUTTON
                id=&dtml-elementid;
                class=justplain
                style="width:20;margin:2;"
                onClick="this.blur();&dtml-actionHandler;();window.event.cancelBubble=true;"
                onMouseOver="mouseOverButton(this);"
                onMouseOut="mouseOffButton(this);"
                title="Left"
                accesskey=&dtml-accesskey;><img src="/&dtml-icon;" widht="16" height="16" alt="" border="0"></BUTTON>
            """, globals())(self,REQUEST)


    def renderjsButtonHandler(self,client=None,REQUEST=None):
        return  """
            //JUSTIFY LEFT BUTTON
            function setJustifyLeft(){
                if(editor.document.queryCommandSupported(DECMD_JUSTIFYLEFT)&&editor.document.queryCommandEnabled(DECMD_JUSTIFYLEFT)){
                    editor.document.execCommand(DECMD_JUSTIFYLEFT);
                }
            }
        """




Globals.InitializeClass(Left)

class Center(FeatureBase):
    """Center Feature"""

    meta_type = 'Center'
    __plugin_kind__ = 'HTML'

    elementid = 'CenterButton'
    command = DECMD_JUSTIFYCENTER
    accesskey = ''
    actionHandler = 'setJustifyCenter'
    updateAppearenceHandler = UH_STANDARDBUTTONHANDLER
    usesLatched = 1
    feature_type = UI_BUTTON

    # Control arguments for Button Placement
    button_group = "Alignments"
    button_group_order = 1


    def renderjsButton(self,client=None,REQUEST=None):
        return  HTML("""
            <BUTTON
                id=&dtml-elementid;
                class=justplain
                style="width:20;margin:2;"
                onClick="this.blur();&dtml-actionHandler;();window.event.cancelBubble=true;"
                onMouseOver="mouseOverButton(this);"
                onMouseOut="mouseOffButton(this);"
                title="Center"
                accesskey=&dtml-accesskey;><img src="/&dtml-icon;" widht="16" height="16" alt="" border="0"></BUTTON>
            """, globals())(self,REQUEST)


    def renderjsButtonHandler(self,client=None,REQUEST=None):
        return  """
            //JUSTIFY CENTER BUTTON
            function setJustifyCenter(){
                if(editor.document.queryCommandSupported(DECMD_JUSTIFYCENTER)&&editor.document.queryCommandEnabled(DECMD_JUSTIFYCENTER)) {
                    editor.document.execCommand(DECMD_JUSTIFYCENTER);
                }
            }
        """


Globals.InitializeClass(Center)

class Right(FeatureBase):
    """Right Feature"""

    meta_type = 'Right'
    __plugin_kind__ = 'HTML'

    elementid = 'RightButton'
    command = DECMD_JUSTIFYRIGHT
    accesskey = ''
    actionHandler = 'setJustifyRight'
    updateAppearenceHandler = UH_STANDARDBUTTONHANDLER
    usesLatched = 1
    feature_type = UI_BUTTON

    # Control arguments for Button Placement
    button_group = "Alignments"
    button_group_order = 2


    def renderjsButton(self,client=None,REQUEST=None):
        return  HTML("""
            <BUTTON
                id=&dtml-elementid;
                class=justplain
                style="width:20;margin:2;"
                onClick="this.blur();&dtml-actionHandler;();window.event.cancelBubble=true;"
                onMouseOver="mouseOverButton(this);"
                onMouseOut="mouseOffButton(this);"
                title="Right"
                accesskey=&dtml-accesskey;><img src="/&dtml-icon;" widht="16" height="16" alt="" border="0"></BUTTON>
            """, globals())(self,REQUEST)


    def renderjsButtonHandler(self,client=None,REQUEST=None):
        return  """
            //JUSTIFY RIGHT BUTTON
            function setJustifyRight(){
                if(editor.document.queryCommandSupported(DECMD_JUSTIFYRIGHT)&&editor.document.queryCommandEnabled(DECMD_JUSTIFYRIGHT)) {
                    editor.document.execCommand(DECMD_JUSTIFYRIGHT);
                }
            }
        """




Globals.InitializeClass(Right)



def initialize(context):
    """Initialize Feature Product"""

    context.registerButtonGroup('Alignments',3)
    context.registerEasyFeature(Left,Left.meta_type,icon="icons/Left.gif")
    context.registerEasyFeature(Center,Center.meta_type,icon="icons/Center.gif")
    context.registerEasyFeature(Right,Right.meta_type,icon="icons/Right.gif")
