# $Header: /usr/custom/cvs/public/EnergyPlusLive/lib/python/Products/EasyEditor/Features/EasyImageFeature.py,v 1.6 2003/09/25 06:49:35 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#


__doc__="""EasyImageFeature Object"""
__version__='$Revision: 1.6 $'[11:-2]


import Globals
from Globals import HTML, DTMLFile
from string import join,split
from Features import FeatureBase, FEATUREADDPERMISSION

from Products.EasyCore.Utils.FunctionTemplate import FunctionTemplate
from Products.EasyEditor.EasyEditorClient.EasyEditorConstants import *
from AccessControl import ClassSecurityInfo
from Products.EasyCore import EasyCorePermissions





FEATUREPLUGINID = 'EasyImageFeature'
PLUGINKIND = 'HTML'

class EasyImageFeature(FeatureBase):
    """EasyImageFeature PlugIn Objects"""

    meta_type = FEATUREPLUGINID
    __plugin_kind__ = PLUGINKIND

    elementid = 'easyimagefeatureButton'
    command = ""
    accesskey = 'i'
    actionHandler = 'insertEasyImageFeature'
    updateAppearenceHandler = UH_STANDARDBUTTONHANDLER
    usesLatched = 1
    feature_type = UI_BUTTON
    #image_meta_types=['Image','EasyImage']
    default_image_meta_types=['EasyImage']

    button_group = "LinkTools"
    button_group_order = 0


    def renderjsButton(self,client=None,REQUEST=None):
        return  HTML("""
               <BUTTON
                id="easyimagefeatureButton"
                class=justplain
                style="width:20;margin:2;"
                onClick="this.blur();insertEasyImageFeature();window.event.cancelBubble=true;"
                onMouseOver="mouseOverButton(this);"
                onMouseOut="mouseOffButton(this);"
                title="Edit Image"
                accesskey="i"><img src="/&dtml-icon;" widht="16" height="16" alt="" border="0"></BUTTON>
            """, globals())(self,REQUEST)

    def renderjsButtonHandler(self,client=None,REQUEST=None):
        return r"""
            function insertEasyImageFeature() {
                if(editor.document.queryCommandSupported(DECMD_INSERTIMAGE)&&editor.document.queryCommandEnabled(DECMD_INSERTIMAGE)) {
                    var sel, rg, oLink;
                    sel = editor.document.selection;
                    rg = sel.createRange();
                    path = null;
                    switch(sel.type) {
                    case "None":
                    case "Text":
                        dictLinkData = openDialog('manage_image_browser',null,'yes','no','yes','no', 'no', 680, 430, DOCUMENT_PATH);
                        if (typeof(dictLinkData)=='object') {
                            rg.pasteHTML(dictAttributes2html("img", dictLinkData, 0, {}));
                            fixRelativeURLs();
                        }
                        break;
                        dictLinkData = null;
                        break;
                    case "Control":
                    parentelement = rg.commonParentElement();
                        if (parentelement.tagName=="IMG") {
                            dictLinkData = linkobj2dictAttributes(parentelement, DOCUMENT_PATH, { path:DOCUMENT_PATH }, { src:'', alt:'', title:'', width:'', height:'', align:'', vspace:'', hspace:'', border:'0' });
                            dictLinkData = openDialog('manage_image_browser',dictLinkData,'yes','no','yes','no', 'no', 680, 430, dictLinkData['path']);
                            if (typeof(dictLinkData)=='object') {
                                parentelement.outerHTML = dictAttributes2html("img", dictLinkData, 0, {})
                                fixRelativeURLs();
                            }
                            break;
                        } else {
                            dictLinkData = openDialog('manage_image_browser',null,'yes','no','yes','no', 'no', 680, 430, DOCUMENT_PATH);
                            if (typeof(dictLinkData)=='object') {
                                parentelement.outerHTML = dictAttributes2html("img", dictLinkData, 0, {})
                                fixRelativeURLs();
                            }
                            break;
                        }
                    }
                    dictLinkData = null;
                }
            }
            """



Globals.InitializeClass(EasyImageFeature)




def initialize(context):
    """Initialize Feature Product"""


    context.registerButtonGroup('LinkTools',7)
    context.registerEasyFeature(EasyImageFeature,FEATUREPLUGINID,icon="icons/EasyImage.gif")
