# $Header: /usr/custom/cvs/public/EnergyPlusLive/lib/python/Products/EasyEditor/Features/EasyLinkFeature.py,v 1.7 2003/09/25 06:49:35 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#



__doc__="""EasyLinkFeature

$Colliberty: EasyLinkFeature.py,v 1.8 2001/07/29 12:02:00 johanc Exp $"""
__version__='$Revision: 1.7 $'[11:-2]


import Globals
from Globals import HTML, DTMLFile
from string import join,split
from Features import FeatureBase, FEATUREADDPERMISSION

from Products.EasyCore.Utils.FunctionTemplate import FunctionTemplate
from Products.EasyEditor.EasyEditorClient.EasyEditorConstants import *

from AccessControl import ClassSecurityInfo
from Products.EasyCore import EasyCorePermissions



FEATUREPLUGINID = 'EasyLinkFeature'
PLUGINKIND = 'HTML'

class EasyLinkFeature(FeatureBase):
    """EasyLinkFeature PlugIn Objects"""

    meta_type = FEATUREPLUGINID
    __feature_kind__ = __plugin_kind__ = PLUGINKIND

    elementid = 'easyLinkFeatureButton'
    command = ""
    accesskey = 'l'
    actionHandler = 'manageEasyLink'
    updateAppearenceHandler = UH_STANDARDBUTTONHANDLER
    usesLatched = 1
    feature_type = UI_BUTTON

    #link_meta_types=['Image','EasyDocument','EasyImage']
    default_link_meta_types=['Image','EasyDocument','EasyImage']

    # Control arguments for Button Placement
    button_group = "LinkTools"
    button_group_order = 1


    def renderjsButton(self,client=None,REQUEST=None):
        return HTML("""
        <BUTTON
            id=createlinkButton
            class=justplain
            style="width:20;margin:2;"
            onClick="this.blur();manageEasyLink();window.event.cancelBubble=true;"
            onMouseOver="mouseOverButton(this);"
            onMouseOut="mouseOffButton(this);"
            title="Edit Link"
            accesskey=l><img src="/&dtml-icon;" widht="16" height="16" alt="" border="0"></BUTTON>
            """, globals())(self,REQUEST)

    def renderjsButtonHandler(self,client=None,REQUEST=None):
        return r"""
            function manageEasyLink() {
                if(editor.document.queryCommandSupported(DECMD_CREATELINK)&&editor.document.queryCommandEnabled(DECMD_CREATELINK)) {
                    var path, sel, rg, oLink;
                    sel = editor.document.selection;
                    rg = sel.createRange();
                    path = null;
                    id = "";
                    href = "";
                    switch(sel.type) {
                      case "Text":
                        rg = trimTextRange(rg);
                      case "None":
                        oLink = getParentLink(rg.parentElement());
                        if (oLink==null && sel.type=="None") break;
                        dictLinkData = linkobj2dictAttributes(oLink, DOCUMENT_PATH,{path:DOCUMENT_PATH}, {id:'', href:'', Id: "", className: "", html: "", target: "", title: "", anchor: "", name: "", querystring: ""});
                        path = dictLinkData['path'];
                        if (path==null || path=='') path = DOCUMENT_PATH;
                        var returnAttributes;
                        returnAttributes = openDialog('manage_link_browser',dictLinkData,'yes','no','no','no', 'no', 680, 430, path);
                        if (typeof(returnAttributes)=='object') {
                            if (oLink!=null) {
                                dictAttributes2linkobj(oLink,returnAttributes, DOCUMENT_PATH);
                            } else {
                                result = rg.execCommand("Unlink");
                                result = rg.execCommand("CreateLink",false,"temp");
                                if (result) {
                                    oLink = getParentLink(rg.parentElement());
                                    if (oLink!=null) dictAttributes2linkobj(oLink,returnAttributes, DOCUMENT_PATH);
                                }
                            }
                            fixRelativeURLs();
                        } else {
                            if (returnAttributes=="DELETELINKS") {
                                result = rg.execCommand("Unlink");
                            }
                        }
                        returnAttributes = null;
                        dictLinkData = null;
                        break;
                      case "Control":
                        var dictLinkData, path, oLink, ctrl;
                        if (rg.length>1) break;
                        ctrl = rg(0);
                        oLink = getParentLink(ctrl.parentNode);
                        dictLinkData= linkobj2dictAttributes(oLink, DOCUMENT_PATH, {path:DOCUMENT_PATH}, {id:'', href:'', oId: "", className: "", html: "", target: "", title: "", anchor: "", name: "", querystring: ""});
                        path = dictLinkData['path'];
                        if (path==null || path=='') path = DOCUMENT_PATH;
                        var returnAttributes;
                        returnAttributes = openDialog('manage_link_browser',dictLinkData,'yes','no','no','no', 'no', 680, 430, DOCUMENT_PATH);
                        if (typeof(returnAttributes)=='object') {
                            if (oLink!=null) {
                                dictAttributes2linkobj(oLink ,returnAttributes, DOCUMENT_PATH);
                            } else {
                                result = rg.execCommand("Unlink");
                                result = rg.execCommand("CreateLink",false,"temp");
                                if (result) {
                                    oLink = getParentLink(ctrl.parentNode);
                                    if (oLink!=null) dictAttributes2linkobj(oLink, returnAttributes, DOCUMENT_PATH);
                                }
                            }
                            fixRelativeURLs();
                        } else {
                            if (returnAttributes=="DELETELINKS") {
                                result = rg.execCommand("Unlink");
                            }
                        }
                    }
                }
            }
            """

Globals.InitializeClass(EasyLinkFeature)



def initialize(context):
    """Initialize Feature Product"""

    context.registerButtonGroup('LinkTools',4)
    context.registerEasyFeature(EasyLinkFeature,FEATUREPLUGINID,icon="icons/EasyLink.gif")


