# $Header: /usr/custom/cvs/public/EnergyPlusLive/lib/python/Products/EasyEditor/Features/EditViewList.py,v 1.4 2003/04/14 12:35:33 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#

__doc__="""EditViewList

$Colliberty: EditViewList.py,v 0.0.1 2001/08/20 15:37:00 johanc Exp $"""
__version__='$Revision: 1.4 $'[11:-2]


import Globals

from Features import FeatureBase
from Products.EasyEditor.EasyEditorClient.EasyEditorConstants import *
from Products.EasyCore.Utils.HTMLFormHelpers import selectTemplateDTML

from AccessControl import ClassSecurityInfo
from Products.EasyCore import EasyCorePermissions

from Products.EasyCore.Utils.Javascript import escape_javascript_id

FEATUREPLUGINID = 'EditViewList'
PLUGINKIND = 'HTML'

class EditViewList(FeatureBase):
    """EditViewList PlugIn Objects"""

    meta_type = FEATUREPLUGINID
    __plugin_kind__ = PLUGINKIND

    elementid = 'editviewlistSelect'
    command = ""
    accesskey = 's'
    actionHandler = 'handleEditViewList'
    updateAppearenceHandler = ''
    usesLatched = 1
    feature_type = UI_SELECT

    dropdown_group = "Views"
    dropdown_group_order = 0

    def renderjsDropDown(self,client=None,REQUEST=None):
        return selectTemplateDTML( \
                items=self.viewMap(isEditable=1), \
                activekeys=[], \
                name='editviewlistSelect', \
                onClick='handleEditViewList(this);' \
            )


    def renderjsDropDownHandler(self,client=None,REQUEST=None):
        return r"""
            function handleEditViewList(self) {
                if (self.value!=currentView) {
                    saveInRegionDict();
                    currentView = self.value;
                    disable();
                    editor.location.href = DOCUMENT_PATH + "/epview_" + currentView + "/manage_editable";
                    DOCUMENT_VIEW_URL = DOCUMENT_URL + "/epview_" + currentView;
                    DOCUMENT_VIEW_PATH = DOCUMENT_PATH + "/epview_" + currentView;
                }
            }
            """

    def renderjsConstants(self,client=None,REQUEST=None):
        currentView = REQUEST.has_key('viewid') and REQUEST['viewid'] or 'default'
        return """var currentView = '%s';""" % (currentView,)

    def renderjsInitEditor(self,client=None,REQUEST=None):
        return r"""document.getElementById('editviewlistSelect').value = currentView;"""



Globals.InitializeClass(EditViewList)




def initialize(context):
    """Initialize Feature Product"""

    context.registerDropDownGroup('Views',1)
    context.registerEasyFeature(EditViewList,FEATUREPLUGINID,icon="icons/EasyImage.gif")
