# $Header: /usr/custom/cvs/public/EnergyPlusLive/lib/python/Products/EasyEditor/Features/Redo.py,v 1.5 2003/09/25 06:49:36 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#

__doc__="""Redo

$Colliberty: Redo.py,v 1.5.2 2001/10/20 15:30:00 johanc Exp $"""
__version__='$Revision: 1.5 $'[11:-2]


import Globals
from Globals import HTML
from string import join,split
from Features import FeatureBase

from Products.EasyEditor.EasyEditorClient.EasyEditorConstants import *

from AccessControl import ClassSecurityInfo
from Products.EasyCore import EasyCorePermissions


FEATUREPLUGINID = 'RedoButton'
PLUGINKIND = 'HTML'

class Redo(FeatureBase):
    """RedoButton PlugIn Objects"""

    meta_type = FEATUREPLUGINID
    __plugin_kind__ = PLUGINKIND

    elementid = 'RedoButton'
    command = "'Redo'"
    accesskey = 'r'
    actionHandler = 'doRedo'
    updateAppearenceHandler = UH_STANDARDBUTTONHANDLER
    usesLatched = 1
    feature_type = UI_BUTTON

    # Control arguments for Button Placement
    button_group = "UndoRedo"
    button_group_order = 1


    def renderjsButton(self,client=None,REQUEST=None):
        return  HTML("""
            <BUTTON
                id="RedoButton"
                class="justplain"
                style="width:20;margin:2;"
                onClick="this.blur();doRedo();window.event.cancelBubble=true;"
                onMouseOver="mouseOverButton(this);"
                onMouseOut="mouseOffButton(this);"
                title="Redo"
                accesskey="u"><img src="/&dtml-icon;" widht="16" height="16" alt="" border="0"></BUTTON>
            """, globals())(self,REQUEST)

    def renderjsButtonHandler(self,client=None,REQUEST=None):
        return r"""
            function doRedo(){
                if(!document.getElementById('RedoButton').disabled&&editor.document.queryCommandSupported('Redo')&&editor.document.queryCommandEnabled('Redo')) {
                    editor.document.execCommand('Redo');
                }
            }
            """

    def renderjsUpdateApperenceCall(self,client=None,REQUEST=None):
        return r"""
            try {
                if(editor.document.queryCommandEnabled('Redo')||editor.document.queryCommandSupported('Redo')){
                    RedoButton.className='justplain';
                    RedoButton.disabled=false;
                    if (RedoButton.children.length>0) {
                        RedoButton.children(0).className='';
                    }
                } else {
                    RedoButton.className='greyed';
                    RedoButton.disabled=true;
                    if (RedoButton.children.length>0) {
                        RedoButton.children(0).className='IMGGREYED';
                    }
                }
            }
            catch(e) {
                //lert(e);
            }
            """


Globals.InitializeClass(Redo)


def initialize(context):
    """Initialize Feature Product"""


    context.registerButtonGroup('UndoRedo',3)
    context.registerEasyFeature(Redo,FEATUREPLUGINID,icon="icons/RedoIcon.gif")
