# $Header: /usr/custom/cvs/public/EnergyPlusLive/lib/python/Products/EasyEditor/Features/ShowContentRegions.py,v 1.5 2003/09/25 06:49:36 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#



__doc__="""ShowContentRegions

$Colliberty: ShowContentRegions.py,v 0.0.1 2001/08/20 15:37:00 johanc Exp $"""
__version__='$Revision: 1.5 $'[11:-2]


import Globals
from Globals import HTML

from Features import FeatureBase

from Products.EasyEditor.EasyEditorClient.EasyEditorConstants import *

from AccessControl import ClassSecurityInfo
from Products.EasyCore import EasyCorePermissions




FEATUREPLUGINID = 'ShowContentRegions'
PLUGINKIND = 'HTML'

class ShowContentRegions(FeatureBase):
    """ShowContentRegions PlugIn Objects"""

    meta_type = FEATUREPLUGINID
    __plugin_kind__ = PLUGINKIND

    elementid = 'showcontentregionsButton'
    command = ""
    accesskey = 's'
    actionHandler = 'showcontentregionsFeature'
    updateAppearenceHandler = UH_STANDARDBUTTONHANDLER
    usesLatched = 1
    feature_type = UI_BUTTON

    button_group = "LinkTools"
    button_group_order = 2


    def renderjsButton(self,client=None,REQUEST=None):
        return  HTML("""
               <BUTTON
                id=&dtml-elementid;
                class=justplain
                style="width:20;margin:2;"
                onClick="this.blur();&dtml-actionHandler;();window.event.cancelBubble=true;"
                onMouseOver="if (showcontentregionsToggle) {this.className='mouseover';} else {this.className='TURNEDON';}"
                onMouseOut="if (showcontentregionsToggle) {this.className='TURNEDON';} else {this.className='justplain';}"
                title="Toggle Content Editable Regions Background"
                accesskey=&dtml-accesskey;><img src="/&dtml-icon;" widht="16" height="16" alt="Toggle Content Editable Regions Background" border="0"></BUTTON>
            """, globals())(self,REQUEST)


    def renderjsConstants(self,client=None,REQUEST=None):
        return r"""
            //START showcontentregionsFeature CONSTANTS
                showcontentregionsToggle = false;
            //STOP  CONSTANTS
            """
    def renderjsButtonHandler(self,client=None,REQUEST=None):
        return r"""
            function showcontentregionsFeature() {
                var index, key;
                var element;
                showcontentregionsToggle = !showcontentregionsToggle;
                regionKeys = dictRegions.Keys().toArray();
                for (index in regionKeys) {
                    key = regionKeys[index];
                    element=edited_document.getElementById(key);
                    if (element!=null && element.tagName!=null) {
                        if (element.tagName!='INPUT' && element.tagName!='TEXTAREA' && element.tagName!='SELECT' && element.tagName!='OPTION') {
                            if (showcontentregionsToggle) {
                                showcontentregionsButton.className = "TURNEDON"
                                element.style.background = dictRegions.Item(key)[1]
                            } else {
                                element.style.background = "";
                                showcontentregionsButton.className = "justplain"
                            }
                        }
                    }
                }
            }
            """

Globals.InitializeClass(ShowContentRegions)




def initialize(context):
    """Initialize Feature Product"""
    context.registerButtonGroup('LinkTools',7)
    context.registerEasyFeature(ShowContentRegions,FEATUREPLUGINID,icon="icons/ShowContentRegions.gif")

