# $Header: /usr/custom/cvs/public/EnergyPlusLive/lib/python/Products/EasyEditor/Features/Undo.py,v 1.4 2003/09/25 06:49:37 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#


__doc__="""Undo

$Colliberty: Undo.py,v 1.5.2 2001/10/20 22:57:00 johanc Exp $"""
__version__='$Revision: 1.4 $'[11:-2]


import Globals
from Globals import HTML, DTMLFile
from string import join,split
from Features import FeatureBase, FEATUREADDPERMISSION

from Products.EasyEditor.EasyEditorClient.EasyEditorConstants import *

from AccessControl import ClassSecurityInfo
from Products.EasyCore import EasyCorePermissions


FEATUREPLUGINID = 'UndoButton'
PLUGINKIND = 'HTML'

class Undo(FeatureBase):
    """InlineBold PlugIn Objects"""

    meta_type = FEATUREPLUGINID
    __plugin_kind__ = PLUGINKIND

    elementid = 'UndoButton'
    command = "'Undo'"
    accesskey = 'u'
    actionHandler = 'doUndo'
    updateAppearenceHandler = UH_STANDARDBUTTONHANDLER
    usesLatched = 1
    feature_type = UI_BUTTON

    # Control arguments for Button Placement
    button_group = "UndoRedo"
    button_group_order = 0


    def renderjsButton(self,client=None,REQUEST=None):
        return  HTML("""
            <BUTTON
                id="UndoButton"
                class="justplain"
                style="width:20;margin:2;"
                onClick="this.blur();doUndo();window.event.cancelBubble=true;"
                onMouseOver="mouseOverButton(this);"
                onMouseOut="mouseOffButton(this);"
                title="Undo"
                accesskey="u"><img src="/&dtml-icon;" widht="16" height="16" alt="" border="0"></BUTTON>
            """, globals())(self,REQUEST)

    def renderjsButtonHandler(self,client=None,REQUEST=None):
        return r"""
            function doUndo(){
                if(!document.getElementById('UndoButton').disabled&&editor.document.queryCommandSupported('Undo')&&editor.document.queryCommandEnabled('Undo')) {
                    editor.document.execCommand('Undo');
                }
            }
            """


    def renderjsUpdateApperenceCall(self,client=None,REQUEST=None):
        return r"""
            try {
                if(editor.document.queryCommandEnabled('Undo')||editor.document.queryCommandSupported('Undo')){
                    UndoButton.className='justplain';
                    UndoButton.disabled=false;
                    if (UndoButton.children.length>0) {
                        UndoButton.children(0).className='';
                    }
                } else {
                    UndoButton.className='greyed';
                    UndoButton.disabled=true;
                    if (UndoButton.children.length>0) {
                        UndoButton.children(0).className='IMGGREYED';
                    }
                }
            }
            catch(e) {
            }
            """


Globals.InitializeClass(Undo)


def initialize(context):
    """Initialize Feature Product"""


    context.registerButtonGroup('UndoRedo',3)
    context.registerEasyFeature(Undo,FEATUREPLUGINID,icon="icons/UndoIcon.gif")
