# $Header: /usr/custom/cvs/public/EnergyPlusLive/lib/python/Products/EasyEditor/Storage/DTMLStorage.py,v 1.11 2004/03/19 12:17:19 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#


__doc__="""Default Storage

$Colliberty: Storage.py,v 0.0.1 2001/05/14 22:06:00 johanc Exp $"""
__version__='$Revision: 1.11 $'[11:-2]

import Globals
from Globals import HTML
from Storage import EasyStorageBase
from OFS.DTMLMethod import addDTMLMethod
from AccessControl import ClassSecurityInfo
from Acquisition import aq_base
from types import StringType
from string import atoi


#Move this to it's own class.
try:
    from mx.Tidy.Tidy import tidy
except:
    tidy=None



from Products.EasyCore import MLOG_TAB

_marker = []

class DTMLStorage(EasyStorageBase):
    """A DTMLStorage Object """

    security = ClassSecurityInfo()
    storage_type="DTMLStorage"
    value_type='string'

    def _saveDTML(self, name, value, editablecontainer, region):
        if name not in editablecontainer.objectIds(spec='DTML Method'):
            try:
                addDTMLMethod(editablecontainer, name, name)
            except:
                delattr(editablecontainer, name)
                addDTMLMethod(editablecontainer, name, name)
        obj = editablecontainer._getOb(name)
        obj.manage_edit(value, obj.title)


    security.declarePrivate('manage_save')
    def manage_save(self, editablecontainer, region, value=None):
        if self.hasChanged(editablecontainer, region):
            self.manage_delete(editablecontainer, region)
            self._setLastChanged(editablecontainer, region, region.lastChanged())
        if value is None:
            value=self.do_get(editablecontainer, region, region.getDefault())
        _storage = getattr(aq_base(editablecontainer),'_' + region.storagecontainerid + '_storage',None)
        if _storage is not None and _storage!=self.id:
            storage = self.getStorage(_storage)
            if storage is not None and hasattr(editablecontainer, region.storagecontainerid):
                storage.manage_delete(editablecontainer, region)
            elif storage is None: raise "StorageException", "Need to have storage [%s] installed to be able to work with this region." % (_storage,)

        self._saveDTML(region.storagecontainerid, value, editablecontainer, region)
        setattr(aq_base(editablecontainer),'_' + region.storagecontainerid + '_storage',self.id)


    def compareHistoryItem(self, editablecontainer, region, item):
        """\
        Compares the Region/Storage with the one added in the History.
        If they differ the region needs to be transformed and re-initiated.
        Return 1 or 0 where 1 is means the are equal.
        """
        raise "Not Implemented"
        ###if item:
        ###    if item.storage_type != self.storage_type or \
        ###           item.property_type != self.property_type or \
        ###           item.property_mode != self.property_mode or \
        ###           item.property_label != self.property_label or \
        ###           item.property_select_variable != self.property_select_variable or \
        ###           item.last_changed != region.lastChanged():
        ###       return 0
        ###    return 1
        ###return 0

    def validityCheck(self, editablecontainer, region):
        raise "Not Implemented"
        ###prop=self.getPropertyInfoFor(editablecontainer, region)
        ###return prop and hasattr(editablecontainer, region.storagecontainerid)


    def do_initilized(self, editablecontainer, region):
        raise "Not Implemented"
        ###self.do_add(editablecontainer, region, region.getDefault())

    def do_transform(self, editablecontainer, region, item):
        raise "Not Implemented"
        ###old_storage=item.getStorage()
        ###if old_storage:
        ###    value=old_storage.getValueForType(editablecontainer, region, self.value_type)
        ###    old_storage.manage_delete(editablecontainer, region)
        ###    self.do_add(editablecontainer, region, value)
        ###    return
        ###self.do_initilized(editablecontainer, region)


    def do_add(self, editablecontainer, region, value):
        raise "Not Implemented"
        ###self._saveProperty(editablecontainer, region, value)
        ###
        ###self._initRSHistoryItem(editablecontainer, region)
        ###self._setLastChanged(editablecontainer, region, region.lastChanged())


    def _getValueForType(self, editablecontainer, region, value_type, default=None):
        """\
        Returns the value of the requested type if possible otherwice default is returned.
        """
        raise "Not Implemented"
        ###if value_type=='list':
        ###    return list(getattr(editablecontainer, region.storagecontainerid, default))
        ###elif value_type=='string':
        ###    return getattr(editablecontainer, region.storagecontainerid, default)
        ###return default


    ## XXX Interface

    def manage_initilized(self, editablecontainer, region):
        raise "Not Implemented"
        ###self.do_initilized(editablecontainer, region)


    def manage_delete_allowed(self, editablecontainer, region):
        raise "Not Implemented"
        ###return 1


    security.declarePrivate('manage_load')
    def manage_load(self, editablecontainer, region, default=None):
        if region.storagecontainerid in editablecontainer.objectIds(spec='DTML Method'):
            obj=editablecontainer._getOb(region.storagecontainerid)
            return obj
        else:
            return getattr(aq_base(editablecontainer), region.storagecontainerid, default)

    def manage_initilized(self, editablecontainer, region):
        return region.storagecontainerid in editablecontainer.objectIds(spec='DTML Method')

    security.declarePrivate('manage_delete')
    def manage_delete(self, editablecontainer, region):
        if editablecontainer._getOb(region.storagecontainerid, default=None) is not None:
            editablecontainer._delObject(region.storagecontainerid)

    def manage_compare(self, editablecontainer, region, obj):
        local_obj=self.manage_load(editablecontainer, region, _marker)
        if local_obj is _marker: return 0
        if getattr(obj, 'meta_type', "marker1")!=getattr(local_obj, 'meta_type', "marker2"):
            return 0
        return obj.read()==local_obj.read()

    def manage_copy(self, editablecontainer, region, parent):
        ob = self.manage_load(editablecontainer, region)
        ob = ob._getCopy(editablecontainer)
        ob._setId(region.storagecontainerid)
        if hasattr(parent, '_setObject'):
            parent._setObject(region.storagecontainerid, ob)
        else:
            setattr(parent, region.storagecontainerid, ob)

    def manage_modification_date(self, name, editablecontainer):
        storage_obj = getattr(aq_base(editablecontainer), name, None)
        if storage_obj is not None:
            return storage_obj.bobobase_modification_time()
        return editablecontainer.bobobase_modification_time()


    def render_html_view(self, editablecontainer, region):
        req=getattr(editablecontainer ,'REQUEST', None)
        region_key=region.id
        content=region.manage_load(editablecontainer, region)
        rows=20
        cols="100%"
        if req is not None and req.has_key('dtpref_cols') and req.has_key('dtpref_rows'):
            rows=max(atoi(req.dtpref_rows),20)
            if req.dtpref_cols[-1]=='%':
                cols= str(min(100, max(25,int(req.dtpref_cols[:-1]))))+'%'
            else:
                cols=str(max(35,int(req.dtpref_cols)))
        return self._render_html_view(editablecontainer
                                    ,region_key=region_key, content=content
                                    , rows=rows, cols=cols, name=region.storagecontainerid, region=region
                                    )

    _render_html_view = HTML("""\
        <textarea name="&dtml-region_key;" wrap="off" cols="&dtml-cols;" rows="&dtml-rows;"><dtml-var content></textarea>
        """, globals())

    ##Storage Init, Config and Change

    render_view_storage_conf = HTML("""\
        <table>
          <tr>
            <td><input type="checkbox" name="use_tidy" value="1"></td>
            <td>Use Tidy</td>
          </tr>
        </table>
        """, globals())

    def manage_view_storage_conf(self, region, REQUEST):
        return self.render_view_storage_conf(self, REQUEST, region=region)

    def manage_save_storage_conf(self, region, REQUEST):
        return self.manage_view_storage_conf(self, region, REQUEST)


Globals.InitializeClass(DTMLStorage)




def initialize(context):
    """Initialize Storage Product"""

    context.registerEasyStorage(DTMLStorage,'DTMLStorage')

