# $Header: /usr/custom/cvs/public/EnergyPlusLive/lib/python/Products/EasyEditor/Storage/NumberPropertyStorages.py,v 1.1 2004/01/14 14:38:56 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#


__doc__="""PropertyStorage

$Colliberty: PropertyStorage.py,v 1.4.37 2001/10/12 18:08:00 johanc Exp $"""
__version__='$Revision: 1.1 $'[11:-2]


import Globals
from Globals import HTML
from PropertyStorage import PropertyStorage
from ZPublisher.Converters import type_converters
from AccessControl import ClassSecurityInfo
from Acquisition import aq_base
from types import StringType, ListType, TupleType
from string import atoi, capitalize

from Products.EasyCore import MLOG_TAB

_marker=[]

POSSIBLE_LINES='possible_'

class BooleanPropertyStorage(PropertyStorage):
    """A BooleanPropertyStorage Object """

    property_type = 'boolean'
    storage_type="BooleanPropertyStorage"
    value_type='boolean'

    def render_html_view(self, editablecontainer, region):
        return """<input type="checkbox" name="%s:boolean" value="1" %s>"""  % (
                      region.id
                    , self.manage_load(editablecontainer, region, region.getDefault()) and 'checked' or ''
                    )

Globals.InitializeClass(BooleanPropertyStorage)


class IntPropertyStorage(PropertyStorage):
    """A IntPropertyStorage Object """

    property_type = 'int'
    storage_type="IntPropertyStorage"
    value_type='int'

    def render_html_view(self, editablecontainer, region):

        return """<input type="text" name="%s:int" value="%s">"""  % (
                      region.id
                    , self.manage_load(editablecontainer, region, region.getDefault())
                    )

Globals.InitializeClass(IntPropertyStorage)


class FloatPropertyStorage(PropertyStorage):
    """A FloatPropertyStorage Object """

    property_type = 'float'
    storage_type="FloatPropertyStorage"
    value_type='float'

    def render_html_view(self, editablecontainer, region):
        return """<input type="text" name="%s:float" value="%s">"""  % (
                      region.id
                    , self.manage_load(editablecontainer, region, region.getDefault())
                    )

Globals.InitializeClass(FloatPropertyStorage)


class LongPropertyStorage(PropertyStorage):
    """A LongPropertyStorage Object """

    property_type = 'long'
    storage_type="LongPropertyStorage"
    value_type='long'

    def render_html_view(self, editablecontainer, region):
        return """<input type="text" name="%s:long" value="%s">"""  % (
                      region.id
                    , self.manage_load(editablecontainer, region, region.getDefault())
                    )


Globals.InitializeClass(LongPropertyStorage)


def initialize(context):
    """Initialize PropertyStorage"""

    context.registerEasyStorage(IntPropertyStorage,     'IntPropertyStorage')
    context.registerEasyStorage(FloatPropertyStorage,   'FloatPropertyStorage')
    context.registerEasyStorage(LongPropertyStorage,   'LongPropertyStorage')
    context.registerEasyStorage(BooleanPropertyStorage, 'BooleanPropertyStorage')

