# $Header: /usr/custom/cvs/public/EnergyPlusLive/lib/python/Products/EasyEditor/Storage/SelectionPropertyStorage.py,v 1.4 2004/03/19 12:17:19 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#


__doc__="""PropertyStorage

$Colliberty: PropertyStorage.py,v 1.4.37 2001/10/12 18:08:00 johanc Exp $"""
__version__='$Revision: 1.4 $'[11:-2]


import Globals
from Globals import HTML, DTMLFile
from PropertyStorage import PropertyStorage
from ListTypeStorages import tuplify
from ZPublisher.Converters import type_converters
from AccessControl import ClassSecurityInfo
from Acquisition import aq_base
from types import StringType, ListType, TupleType
from string import atoi, capitalize

from Products.EasyCore import MLOG_TAB

_marker=[]

POSSIBLE_LINES='possible_'




class SelectionPropertyStorage(PropertyStorage):
    """A SelectionPropertyStorage Object """

    property_type = 'selection'
    storage_type="SelectionPropertyStorage"
    value_type='string'
    do_show_empty_default=''
    select_empty_default=''

    security = ClassSecurityInfo()


    def validityCheck(self, editablecontainer, region):
        prop=self.getPropertyInfoFor(editablecontainer, region)
        return prop and hasattr(editablecontainer, region.storagecontainerid) and\
               prop.has_key('') and hasattr(editablecontainer, prop['select_variable'])


    def render_html_view(self, editablecontainer, region):
        REQUEST=getattr(editablecontainer ,'REQUEST', None)
        select_variable=region.property_select_variable
        select_list=getattr(editablecontainer, select_variable, None)
        if select_list is None:
            return """<div class="form-text">No value for %s.</div>""" % select_variable

        select_list=tuplify(select_list)

        value=self.manage_load(editablecontainer, region, region.getDefault())
        return self._default_render_html_view(self, REQUEST=REQUEST
                            , value=value
                            , select_list=select_list
                            , list_size=min(7, len(select_list))
                            , id=region.storagecontainerid
                            )

    _default_render_html_view=HTML("""\
        <div class="form-element">
        <select name="&dtml-id;:list" size="&dtml-list_size;">
          <dtml-in select_list prefix="option">
             <option value="&dtml-option_key;" <dtml-var "value==option_key and 'SELECTED' or ''">><dtml-var option_item html_quote></option>
          </dtml-in>
        </select>
        </div>
        """, globals())


    def manage_view_storage_conf(self, region, REQUEST):
        return self._default_property_config(self, region=region, REQUEST=REQUEST)


    _default_property_config=DTMLFile("dtml/SelectionPropertyStorage", globals())


    def manage_save_storage_conf(self, region, REQUEST):
        region.property_mode = REQUEST.get('property_mode',getattr(region,'property_mode', self.property_mode))
        region.property_label = REQUEST.get('property_label',getattr(region,'property_label', self.property_label))
        region.property_select_variable = REQUEST.get('property_select_variable',getattr(region,'property_select_variable', self.property_select_variable))
        region.do_show_empty_default=REQUEST.get('do_show_empty_default',getattr(region,'do_show_empty_default', self.do_show_empty_default))
        region.select_empty_default=REQUEST.get('select_empty_default',getattr(region,'select_empty_default', self.select_empty_default))

Globals.InitializeClass(SelectionPropertyStorage)






def initialize(context):
    """Initialize PropertyStorage"""

    context.registerEasyStorage(SelectionPropertyStorage,   'SelectionPropertyStorage')
