# $Header: /usr/custom/cvs/public/EnergyPlusLive/lib/python/Products/EasyEditor/Storage/StringPropertyStorages.py,v 1.1 2004/01/14 14:38:56 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#


__doc__="""StringPropertyStorages

$Colliberty: StringPropertyStorages.py,v 1.4.37 2001/10/12 18:08:00 johanc Exp $"""
__version__='$Revision: 1.1 $'[11:-2]


import Globals
from Globals import HTML
from PropertyStorage import PropertyStorage
from ZPublisher.Converters import type_converters
from AccessControl import ClassSecurityInfo
from Acquisition import aq_base
from types import StringType, ListType, TupleType
from string import atoi, capitalize


from Products.EasyCore import MLOG_TAB



_marker=[]

POSSIBLE_LINES='possible_'


def quotedHTML(text,
               character_entities=(
                   (('&'), '&amp;'),
                   (("<"), '&lt;' ),
                   ((">"), '&gt;' ),
                   (('"'), '&quot;'))): #"
    for re,name in character_entities:
        if text.find(re) >= 0: text=name.join(text.split(re))
    return text


class StringPropertyStorage(PropertyStorage):
    """A StringPropertyStorage Object """

    property_type = 'string'
    storage_type="StringPropertyStorage"
    value_type='string'

    def render_html_view(self, editablecontainer, region):
        req=getattr(editablecontainer ,'REQUEST', None)
        cols=50
        if req is not None and req.has_key('dtpref_cols') and req.has_key('dtpref_rows'):
            cols=max(atoi(req.dtpref_cols)-15,20)
        value=self.manage_load(editablecontainer, region, region.getDefault())
        value=quotedHTML(value)
        return """<input type="text" name="%s:string" value="%s" size="%s">"""  % (region.id, value, cols)

Globals.InitializeClass(StringPropertyStorage)




class TextPropertyStorage(StringPropertyStorage):
    """A TextPropertyStorage Object """

    property_type = 'text'
    storage_type="TextPropertyStorage"
    value_type='text'

    def render_html_view(self, editablecontainer, region):
        req=getattr(editablecontainer ,'REQUEST', None)
        rows=20
        cols=50
        if req is not None and req.has_key('dtpref_cols') and req.has_key('dtpref_rows'):
            rows=max(atoi(req.dtpref_rows),20)
            cols=max(atoi(req.dtpref_cols)-15,20)
        value=self.manage_load(editablecontainer, region, region.getDefault())

        return """<textarea name="%s:text" rows="%s" cols="%s">%s</textarea>"""  % (region.id, rows, cols, value)


Globals.InitializeClass(TextPropertyStorage)

def initialize(context):
    """Initialize PropertyStorage"""

    context.registerEasyStorage(StringPropertyStorage,   'StringPropertyStorage')
    context.registerEasyStorage(TextPropertyStorage,     'TextPropertyStorage')
