# $Header: /usr/custom/cvs/public/EnergyPlusLive/lib/python/Products/EasyEditor/__init__.py,v 1.7 2003/09/25 06:49:37 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#
#

__doc__ = """EasyEditor initialization module."""
__version__='$Revision: 1.7 $'[11:-2]



import EasyEditor, Storage, Features
include_modules = (EasyEditor, Storage, Features, )

import EasyEditable, EasyTemplates, EditableRegions
include_modules = include_modules + (EasyEditable, EasyTemplates, EditableRegions)

import EasyDocument, EasyRoot, EasyFolder; include_modules = include_modules + (EasyDocument, EasyRoot,EasyFolder)

import Styles; include_modules = include_modules + (Styles,)


import BrowserFolder; include_modules = include_modules + (BrowserFolder,)

import EasyNewsItem; include_modules = include_modules + (EasyNewsItem,)

import EasyPropertyContainer; include_modules = include_modules + (EasyPropertyContainer,)


#import MetaDataTemplates; include_modules = include_modules + (MetaDataTemplates,)

import EasySimpleObject; include_modules = include_modules + (EasySimpleObject,)

from ImageFile import ImageFile




def initialize(context):
    """Initialize the EasyEditor product.
    """
    for m in include_modules:
            m.initialize(context)



misc_={
    'EasyEditor':           ImageFile('images/EasyEditor.gif',   globals(),),
    'EasySimpleItem':       ImageFile('images/EasySimpleItem.gif',   globals()),
    'EasyTemplate':         ImageFile('images/EasyTemplate.gif',   globals()),
    'button_seperator.gif': ImageFile('images/button_seperator.gif',   globals()),
    'transparent50.gif':    ImageFile('images/transparent50.gif',   globals()),
    'object_browser_up.gif':ImageFile('images/object_browser_up.gif',   globals()),
    }

from Products.EasyEditor.BrowserRegistry import BrowserRegistry

BrowserRegistry.register(('MSIE 6.0','windows'), ('DHTMLEditionComponent5.5',))
BrowserRegistry.register(('MSIE 5.5','windows'), ('DHTMLEditionComponent5.5',))




from App.FactoryDispatcher import FactoryDispatcher

import Acquisition, sys, Products
from AccessControl.PermissionMapping import aqwrap
import ExtensionClass
from Products.EasyCore.EasyEditorConf import EASYEDITORID


class ofWrapper(ExtensionClass.Base):
    def __init__(self, o):
        self._o=o
    def __of__(self, parent): return self.__dict__['_o']


class __FactoryDispatcher__(FactoryDispatcher):
    """Overrides the factory dispatcher to enable adding of
       the same meta_types under different names"""

    def __getattr__(self, name):
        p=self.__dict__['_product']
        d=p.__dict__
        if hasattr(p,name) and d.has_key(name):
            m=d[name]
            w=getattr(m, '_permissionMapper', None)
            if w is not None:
                m=ofWrapper(aqwrap(m, getattr(w,'aq_base',w), self))

            return m

        m='Products.%s' % p.id
        if sys.modules.has_key(m) and sys.modules[m]._m.has_key(name):
            return sys.modules[m]._m[name]

        if self.__dict__.has_key('_v_in_getattr') and self.__dict__['_v_in_getattr'] != None:
            # Only look through the products if we isn't doing that already, to prevent recursivness
            self.__dict__['_v_in_getattr'] == None
            raise AttributeError, name

        self.__dict__['_v_in_getattr'] = 1

        editor=getattr(self.__dict__['_d'], EASYEDITORID)
        if editor:
            products = editor.templateValues()
            self.__dict__['_v_in_getattr'] = None
            for product in products:
                ###if product['id'] == name:
                if product.id == name:
                    self.subclass_title = product.title
                    self.subclass = name
                    m='Products.%s' % p.id
                    if sys.modules.has_key(m) and sys.modules[m]._m.has_key('manage_addEasyObjectForm'):
                        return sys.modules[m]._m['manage_addEasyObjectForm']

            #if name[0:2]=='c_':
            #    name=name[2:]
            #    for product in products:
            #        if product['id'] == name:
            #            self.subclass_title = product['title']
            #            self.subclass = name
            #            #return self
            #            #return


        raise AttributeError, name
