# $Header: /usr/custom/cvs/public/EnergyPlusLive/lib/python/Products/EasyMailService/EasyMailService.py,v 1.4 2003/06/11 11:52:39 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#
__doc__='''EasyMailService product.'''
__version__='$Revision: 1.4 $'[11:-2]

import Globals
from Products.MailHost.MailHost import MailHost
from Globals import DTMLFile
from Products.EasyCore.EasyCorePermissions import *
from AccessControl import ClassSecurityInfo

EASYMAILSERVICE='EasyMailService'

class EasyMailService(MailHost):
    """
    The mailservice is currently just a mailhost.
    This will probably be extended with a mail queue in the future.
    """

    security = ClassSecurityInfo()

    meta_type = 'EasyMailService'

    isPrincipiaFolderish=1


    security.declarePublic('getSMTPHost')
    def getSMTPHost(self):
        return self.smtp_host

    security.declarePublic('getSMTPPort')
    def getSMTPPort(self):
        return self.smtp_port


Globals.InitializeClass(EasyMailService)


manage_addEasyMailServiceForm=DTMLFile('dtml/addEasyMailService_form', globals())

def manage_addEasyMailService(self, title='', smtp_host=None,
                       localhost='localhost', smtp_port=25,
                       timeout=1.0, REQUEST=None):
    ' add a EasyMailService into the system '

    id="EasyMailService"
    title=str(title)
    if smtp_host is not None:
        smtp_host=str(smtp_host)
    if type(smtp_port) is not type(1):
        smtp_port=string.atoi(smtp_port)

    i=EasyMailService()            #create new mail host
    i.id=id                 #give it id
    i.title=title           #title
    i._init(smtp_host=smtp_host, smtp_port=smtp_port)

    self=self.this()
    self._setObject(id,i)   #register it
    if REQUEST is not None:
        REQUEST['RESPONSE'].redirect(self.absolute_url()+'/manage_main')



def initialize(context):
    """Initialize EasyMailService Product"""


    context.registerClass(
        EasyMailService,
        permission=EasyMailServiceAdd,
        constructors=(manage_addEasyMailServiceForm,
                      manage_addEasyMailService),
        icon='icons/EasyMailService.gif',
    )


