7# $Header: /usr/custom/cvs/public/EnergyPlusLive/lib/python/Products/EasyPresentationHelpers/EasyPresentationHelpers.py,v 1.12 2004/01/13 12:47:51 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#

__doc__='''EasyPresentationHelpers
$Id: EasyPresentationHelpers.py,v 1.12 2004/01/13 12:47:51 johanc Exp $'''
__version__='$Revision: 1.12 $'[11:-2]

import Globals

from AccessControl import ClassSecurityInfo
from Globals import DTMLFile, HTML
from ExtensionClass import Base
from string import join, replace, capwords, capitalize
from DateTime import DateTime
from types import ListType, StringType, TupleType, DictType
from RestrictedPython.Utilities import same_type
from Products.EasyCore.TagUtils import strip_html

from Products.EasyCore import MLOG_TAB

SeqvenceType = (ListType,TupleType)

class EasyPresentationHelpers(Base):
    """Help functions for presentation"""

    security = ClassSecurityInfo()

    #security.declarePrivate('manage_options_publish')
    def dtmlLink(self,
            css_class='',
            onmouseover='',
            url='',
            sname = 'togglekey',
            sdefault='id',
            adefault='',
            stitle='Id',
            atitle='',
            usehtml=0,
            REQUEST=None
        ):
        return ""

    def dtmlFormStartForLinkGroups(self,action='',method='post',encoding='', REQUEST=None):
        if REQUEST and not action: action = REQUEST['URL']
        result = '<form action="%s" method="%s"' % (action,method)
        if encoding: result = result + ' encoding="%s"' % (encoding)
        result = result + ">"
        return result

    def dtmlFormStopForLinkGroups(self,REQUEST=None):
        return """</form>"""

    def dtmlHiddenFieldsForLinkGroups(self,REQUEST=None):
        result = ''
        if REQUEST and REQUEST.has_key('sortlinkgroups'):
            for key,value in REQUEST['sortlinkgroups']:
                if not (REQUEST.has_key(key+"_rendered") and REQUEST[key+"_rendered"]):
                    if REQUEST.has_key(key): value = REQUEST[key]
                    if type(value) in SeqvenceType:
                        for v in value:
                            result = result + '<input type="hidden" name="%s" value="%s">' % (key,v)
                    else:
                        result = result + '<input type="hidden" name="%s" value="%s">' % (key,value)
        return result

    def getRemainingWidth(self, list, inprecent=1, maxwidth=100):
        result = str(maxwidth)
        if inprecent: result = result + "%"
        return result

    def values2items(self, values, cap=0, capword=0, underscore2space=0):
        if type(values)==type(''): values= (values,)
        items=()
        for value in values:
            if cap:
                items = items + ((value, capitalize(replace(value,'_',' '))),)
            elif capword:
                items = items + ((value, capwords(replace(value,'_',' '))),)
            elif underscore2space:
                items = items + ((value, replace(value,'_',' ')),)
            else:
                items = items + ((value, value),)
        return items


    def dtmlCheckboxList(self,
            name = 'selectkey',
            elementid='',
            header='',
            width='',
            intendwidth='',
            table_align='',
            table_css_class='',
            th_css_class='list-header',
            header_css_class='tab-small',
            td_css_class='tab-small',
            css_style='',
            onClick='',
            onSelect='',
            sdefault=('method',),
            title='Method',
            items = (('method','Method'),('menu','Menu')),
            hiddendefault='None',
            usekeyasname = 0,
            REQUEST=None
        ):
        """
        Serves a checkbox list with Link Group awareness
        The layout is a table which can be modified by:
          - Orientation
          - Width
          - Apperance:
             o border,
             o cellpadding and, cellspacing,
             o css classes and styles
        """
        if REQUEST and REQUEST.has_key(name): activekeys = REQUEST[name]
        else: activekeys = sdefault
        if type(activekeys)==type(()): activekeys = list(activekeys)
        if type(activekeys)!=type([]): activekeys = [activekeys]
        if REQUEST:
            REQUEST.set(name+"_rendered", 1)
            if not REQUEST.has_key(name):
                REQUEST.set(name, sdefault)
        return self.dtmlCheckboxListVerticalDTML(
            name=name+":list",
            elementid=elementid,
            header=header,
            width=width,
            intendwidth=intendwidth,
            border = 0,
            cellspacing = 0,
            cellpadding = 2,
            table_css_class=table_css_class,
            th_css_class=th_css_class,
            header_css_class=header_css_class,
            td_css_class=td_css_class,
            table_align= table_align,
            onClick=onClick,
            onSelect=onSelect,
            items=items,
            activekeys=activekeys)

    dtmlCheckboxListVerticalDTML = HTML( """
      <table border="&dtml-border;" cellspacing="&dtml-cellspacing;" cellpadding="&dtml-cellpadding;" class="&dtml-table_css_class;"<dtml-if table_align> align="&dtml-table_align;"</dtml-if><dtml-if elementid> id="&dtml-elementid;"</dtml-if><dtml-if width> width="&dtml-width;"</dtml-if>>
      <dtml-if header>
        <tr class="&dtml-th_css_class;">
          <dtml-if intendwidth>
            <td width="&dtml-intendwidth;"></td>
          </dtml-if>
          <td width="20"></td>
          <td><dtml-if header><strong class="&dtml-header_css_class;"><dtml-var header></strong></dtml-if></td>
        </tr>
      </dtml-if>
      <dtml-in items>
        <tr>
          <dtml-if intendwidth>
            <td width="&dtml-intendwidth;"></td>
          </dtml-if>
          <td class="&dtml-td_css_class;"><input type="checkbox"
          name="<dtml-if usekeyasname><dtml-var sequence-key><dtml-else><dtml-var name></dtml-if>"
          value="<dtml-if usekeyasname><dtml-var sequence-item><dtml-else><dtml-var sequence-key></dtml-if>"
          <dtml-if usekeyasname><dtml-if "_['sequence-item'] in activekeys"> checked</dtml-if><dtml-else><dtml-if "_['sequence-key'] in activekeys"> checked</dtml-if></dtml-if>></td>
          <td class="&dtml-td_css_class;"><LABEL for=<dtml-if usekeyasname><dtml-var sequence-key><dtml-else><dtml-var name></dtml-if>"><dtml-var sequence-item></LABEL></td>
        </tr>
      </dtml-in items>
      </table>
    """, globals())


    def dtmlSelectBox(self,
            css_class='',
            css_style='',
            onClick='',
            onSelect='',
            name = 'selectkey',
            elementid='',
            sdefault=('method',),
            title='Method',
            height = 0,
            multiple = 0,
            unselectable=0,
            items = (('method','Method'),('menu','Menu')),
            hiddendefault=None,
            REQUEST=None
        ):
        if REQUEST and REQUEST.has_key(name): activekeys = REQUEST[name]
        else: activekeys = sdefault
        if type(activekeys)==TupleType: activekeys = list(activekeys)
        if type(activekeys)!=ListType: activekeys = [activekeys]
        if type(items)==TupleType: items = list(items)
        if type(items)!=ListType: items = [items]
        item_keys = ()
        for item in items:
            item_keys = item_keys + (item[0],)
        for key in activekeys:
            if key not in item_keys:
                items = items + [(key,key,),]
        if multiple: name=name+":list"
        if REQUEST:
            REQUEST.set(name+"_rendered", 1)
            if not REQUEST.has_key(name):
                REQUEST.set(name, sdefault)
        return self.selectTemplateDTML(
            name=name,
            cssstyle=css_class,
            css_style=css_style,
            onClick=onClick,
            onSelect=onSelect,
            height=height,
            multiple=multiple,
            items=items,
            hiddendefault=hiddendefault,
            activekeys=activekeys)


    #Usage: dtmlToggleLink
    # dtmlToggleLink(self,
    #        css_class='',
    #        onmouseover='',
    #        url='',
    #        sname = 'togglekey',
    #        sdefault='id',
    #        adefault='',
    #        stitle='Id',
    #        atitle='',
    #        usehtml=0,
    #        usetablecells=0,
    #        usecheckbox='',
    #        REQUEST=None
    #    ):

    def dtmlToggleLink(self,
            css_class='',
            onmouseover='',
            url='',
            sname = 'togglekey',
            sdefault='id',
            adefault='',
            stitle='Id',
            atitle='',
            usehtml=0,
            usetablecells=0,
            usecheckbox='',
            box_style='',
            box_class='',
            REQUEST=None
        ):
        fname=sname
        if fname.count(':')>0:
            sname, stype = fname.split(':')
        if REQUEST is None and hasattr(self, 'REQUEST'):
            REQUEST = self.REQUEST
        if REQUEST and REQUEST.has_key(sname):
            svalue = REQUEST[sname]
            REQUEST.set(sname+"_rendered", 1)
        else:
            svalue = sdefault
            if REQUEST:
                REQUEST.set(sname, sdefault)
                REQUEST.set(sname+"_rendered", 1)
        if REQUEST and url=='': url = REQUEST['URL']
        if REQUEST and REQUEST.has_key('sortlinkgroups'):
            appendgroupkeys = []
            for key,value in REQUEST['sortlinkgroups']:
                if key!=sname:
                    if REQUEST.has_key(key):
                        if type(REQUEST[key]) in SeqvenceType:
                            for v in REQUEST[key]:
                                appendgroupkeys.append("%s=%s"%(key,v))
                        else:
                            appendgroupkeys.append("%s=%s"%(key,REQUEST[key]))
                    else:
                        if type(value) in SeqvenceType:
                            for v in value:
                                appendgroupkeys.append("%s=%s"%(key,v))
                        else:
                            appendgroupkeys.append("%s=%s"%(key,value))
            if appendgroupkeys: appendgroupkeys = "&" + join(appendgroupkeys,'&')
            else: appendgroupkeys=''
        else: appendgroupkeys=''
        if box_style or box_class:
            tag=usecheckbox and 'div' or 'span'
            add_box_start='<%s style="%s" class="%s">' % (tag, box_style, box_class)
            add_box_stop='</%s>' % (tag,)
        else:
            add_box_start=''
            add_box_stop=''
        if not atitle: atitle=stitle
        if usecheckbox:
            return self.dtmlToggleLinkDTMLTable(
                  css_class = css_class,
                  onmouseover = onmouseover,
                  url = url,
                  sname = fname,
                  sdefault = sdefault,
                  adefault = adefault,
                  svalue = svalue,
                  stitle=stitle,
                  atitle=atitle,
                  usehtml = usehtml,
                  usetablecells=usetablecells,
                  usecheckbox=usecheckbox,
                  appendgroupkeys=appendgroupkeys,
                  add_box_start=add_box_start,
                  add_box_stop=add_box_stop,
                  client=None,REQUEST=REQUEST
                )
        return self.dtmlToggleLinkDTMLNoTable(
              css_class = css_class,
              onmouseover = onmouseover,
              url = url,
              sname = fname,
              sdefault = sdefault,
              adefault = adefault,
              svalue = svalue,
              stitle=stitle,
              atitle=atitle,
              usehtml = usehtml,
              usetablecells=usetablecells,
              usecheckbox=usecheckbox,
              appendgroupkeys=appendgroupkeys,
              add_box_start=add_box_start,
              add_box_stop=add_box_stop,
              client=None,REQUEST=REQUEST
            )

    dtmlToggleLinkDTMLTable = HTML("""<dtml-var add_box_start><table cellpadding="0" cellspacing="0" border="0" align="left">
    <tr><td><dtml-if usecheckbox><input type="hidden" name="&dtml-sname;:default" value="&dtml-adefault;"><input type="checkbox" name="&dtml-sname;" value="&dtml-sdefault;"<dtml-if "sdefault == svalue"> checked</dtml-if>></dtml-if></td>
    <td><a<dtml-if css_class> class="&dtml-css_class;"</dtml-if> href="&dtml-url;?<dtml-if "sdefault == svalue">&dtml-sname;=&dtml-adefault;<dtml-else>&dtml-sname;=&dtml-sdefault;</dtml-if>&dtml-appendgroupkeys;" <dtml-if onmouseover>onMouseOver="window.status='&dtml-onmouseover;'; return true" onMouseOut="window.status=''; return true"</dtml-if>><dtml-if usehtml><dtml-if "sdefault == svalue">&dtml-atitle;<dtml-else>&dtml-stitle;</dtml-if><dtml-else><dtml-if "sdefault == svalue"><strong>&dtml-atitle;</strong><dtml-else>&dtml-stitle;</dtml-if></dtml-if></a></td></tr></table><dtml-var add_box_stop>""", globals())

    dtmlToggleLinkDTMLNoTable = HTML( """<dtml-var add_box_start><a<dtml-if css_class> class="&dtml-css_class;"</dtml-if> href="&dtml-url;?<dtml-if "sdefault == svalue">&dtml-sname;=&dtml-adefault;<dtml-else>&dtml-sname;=&dtml-sdefault;</dtml-if>&dtml-appendgroupkeys;" <dtml-if onmouseover>onMouseOver="window.status='&dtml-onmouseover;'; return true" onMouseOut="window.status=''; return true"</dtml-if>><dtml-if usehtml><dtml-if "sdefault == svalue">&dtml-atitle;<dtml-else>&dtml-stitle;</dtml-if><dtml-else><dtml-if "sdefault == svalue"><strong>&dtml-atitle;</strong><dtml-else>&dtml-stitle;</dtml-if></dtml-if></a><dtml-var add_box_stop>""", globals())


    def dtmlSortLink(self,client=None,REQUEST=None,
            css_class='',
            onmouseover='',
            url='',
            sname = 'skey',
            rname = 'rkey',
            sdefault='id',
            rdefault='',
            svalue='',
            rvalue='',
            title='Id',
            stitle='',
            rtitle='',
            srtitle='',
            usehtml=0
        ):
        if REQUEST and REQUEST.has_key(sname): skey = REQUEST[sname]
        else:
            skey = sdefault
            if REQUEST: REQUEST.set(sname, sdefault)
        if REQUEST and REQUEST.has_key(rname): rkey = REQUEST[rname]
        else:
            rkey = rdefault
            if REQUEST: REQUEST.set(rname, rdefault)
        if REQUEST and url=='': url = REQUEST['URL']
        appendgroupkeys = self.getSortLinkGroupsURLValues(exclude=[sname,rname], REQUEST=REQUEST)
        if not stitle: stitle=title
        if not rtitle: rtitle=stitle
        if not srtitle: srtitle=rtitle
        return self.dtmlSortLinkDTML(
              css_class = css_class,
              onmouseover = onmouseover,
              url = url,
              sname = sname,
              rname = rname,
              sdefault = sdefault,
              rdefault = rdefault,
              skey = skey,
              rkey = rkey,
              svalue = svalue,
              rvalue = rvalue,
              title=title, stitle=stitle, rtitle=rtitle, srtitle=srtitle,
              usehtml = usehtml,
              appendgroupkeys=appendgroupkeys,
              client=client,REQUEST=REQUEST
            )


    dtmlSortLinkDTML = HTML( """
    <a<dtml-if css_class> class="&dtml-css_class;"</dtml-if> href="&dtml-url;?&dtml-sname;=&dtml-svalue;<dtml-if "rkey == rdefault and skey==svalue">&&dtml-rname;=&dtml-rvalue;<dtml-else>&&dtml-rname;=&dtml-rdefault;</dtml-if>&dtml-appendgroupkeys;"
      <dtml-if onmouseover>onMouseOver="window.status='&dtml-onmouseover;'; return true" onMouseOut="window.status=''; return true"</dtml-if>
    ><dtml-if usehtml><dtml-if "skey == svalue and not rkey == rvalue">&dtml-stitle;<dtml-elif "not skey == svalue and rkey == rvalue">&dtml-rtitle;<dtml-elif "skey == svalue and rkey == rvalue">&dtml-srtitle;<dtml-else>&dtml-title;</dtml-if></a><dtml-else><nobr><dtml-if "skey == svalue and not rkey == rvalue"><strong>&dtml-stitle;</strong><dtml-elif "not skey == svalue and rkey == rvalue"><i>&dtml-rtitle;</i><dtml-elif "skey == svalue and rkey == rvalue"><strong><i>&dtml-srtitle;</i></strong><dtml-else>&dtml-title;</dtml-if></nobr></a></dtml-if>
    """, globals())


    def dtmlInitSortLinkGroups(self,client=None,REQUEST=None, **kw):
        if REQUEST:
          groups = []
          for key,value in kw.items():
            groups.append((key,value))
            if not REQUEST.has_key(key):
                REQUEST.set(key, value)
          REQUEST.set('sortlinkgroups',groups)

    def getSortLinkGroupsURLValues(self,exclude=[],REQUEST=None, returnAsList=0):
        if hasattr(self,'REQUEST') or REQUEST is not None:
            r = REQUEST or self.REQUEST
        else: raise "getSortLinkGroupsURLValues Exception", "REQUEST not found"
        appendgroupkeys = []
        if r and r.has_key('sortlinkgroups'):
            for key,value in r['sortlinkgroups']:
                if key not in exclude:
                    if r.has_key(key):
                        if type(r[key]) in SeqvenceType:
                            for v in r[key]:
                                appendgroupkeys.append("%s=%s"%(key,v))
                        else:
                            appendgroupkeys.append("%s=%s"%(key,r[key]))
                    else:
                        if type(value) in SeqvenceType:
                            for v in value:
                                appendgroupkeys.append("%s=%s"%(key,v))
                        else:
                            appendgroupkeys.append("%s=%s"%(key,value))
        if not returnAsList: appendgroupkeys = "&" + join(appendgroupkeys,'&')
        return appendgroupkeys

    def dtmlFormatDate(self,date, fmt='%Y-%m-%d', nobr=1, alttext='', client=None,REQUEST=None, **kw):
        html = """<dtml-var date fmt="%s">""" % (fmt)
        if nobr: html = "<nobr>" + html + "</nobr>"
        dateDTML = HTML(html,globals())
        if type(date)==type(DateTime()):
            return dateDTML(date=date,client=client,REQUEST=REQUEST)
        if alttext: return alttext
        return date

    #Usage:
    #from Products.EasyCore.Utils.HTMLFormHelpers import selectTemplateDTML
    #
    # Input arguments:
    #   name:string,
    #   activekeys: list of active keys|active key string,
    #   items:list of (key,value) pairs
    #   unselectable = 0|1
    #   elementid:string
    #   onSelect:js_string
    #   onClick:js_string
    #   cssclass:string
    #   cssstyle:css_string
    #   size:string | height:string
    #   multiple = 0|1
    #   hiddendefault:string

    selectTemplateDTML = HTML( """
      <dtml-if hiddendefault><input type="hidden" name="&dtml.missing-name;:default" value="&dtml.missing-hiddendefault;"></dtml-if>
      <SELECT name="&dtml.missing-name;"<dtml-if "_.has_key('unselectable') and unselectable"> unselectable="&dtml-unselectable;"</dtml-if><dtml-if "_.has_key('elementid') and elementid"> id="&dtml-elementid;"</dtml-if><dtml-if "_.has_key('onSelect') and onSelect"> onSelect="&dtml-onSelect;"</dtml-if><dtml-if "_.has_key('onClick') and onClick"> onClick="&dtml-onClick;"</dtml-if><dtml-if "_.has_key('cssclass') and cssclass"> class="&dtml-cssclass;"</dtml-if><dtml-if "_.has_key('cssstyle') and cssstyle"> style="&dtml-cssstyle;"</dtml-if><dtml-if "_.has_key('height') and height"> size="&dtml-height;"</dtml-if><dtml-if "_.has_key('size') and size"> size="&dtml-size;"</dtml-if><dtml-if "_.has_key('multiple') and multiple"> multiple</dtml-if>>
       <dtml-in items>
        <OPTION value="&dtml-sequence-key;" <dtml-if "_['sequence-key'] == activekeys or _['sequence-key'] in activekeys">SELECTED</dtml-if>>&dtml-sequence-item;</OPTION>
       </dtml-in>
      </SELECT>
    """, globals())

    #
    #
    # InputArguments:
    #   name:string,
    #   activekeys:list of active keys,
    #   items:list of (key,value) pairs
    #
    checkableTableRows = HTML("""
      <dtml-in items>
        <TR>
          <TD><INPUT type="checkbox" name="&dtml-name;" value="&dtml-sequence-key;" <dtml-if "_['sequence-key'] == activekeys or _['sequence-key'] in activekeys">CHECKED</dtml-if>></TD>
          <TD><strong>&dtml-sequence-item;</strong></TD>
        </TR>
      </dtml-in>
    """,globals())


    #MINI COUNTER for solving problems with dynamic columns in a table
    def mini_counter(self, init=None, REQUEST=None):
        if hasattr(self,'REQUEST') or REQUEST is not None:
            r = self.REQUEST or REQUEST
            if init is not None or not r.has_key('mini_count'):
                try:counter = int(init) - 1
                except: counter=0
            else:
                try:counter = int(r['mini_count'])
                except: counter=0
            r.set('mini_count',counter+1)
            return counter
        raise "mini_counter exception", "REQUEST not found"

    def calcTDProcent(self, sequence, initialprocent=100, defaultprocent=100, REQUEST=None):
        i = len(sequence)
        if i ==0: return initialprocent
        if type(initialprocent)!=type(0):
            initialprocent= int(initialprocent)
        return divmod(initialprocent, i)


    #BATCH HELPERS
    def initBatchHelpers(self, result, start_var_name='b_start', size_var_name='b_size', orphan_var_name='b_orphan', REQUEST=None):
        if hasattr(self,'REQUEST') or REQUEST is not None:
            r = self.REQUEST or REQUEST
        try: b_start = int(r[start_var_name])
        except: b_start = 1
        if b_start<0: b_start=1
        r.set(start_var_name, b_start)
        try: b_size = int(r[size_var_name])
        except: b_size = 10
        if b_size<0: b_size=1
        r.set(size_var_name, b_size)
        try: b_orphan = int(r[orphan_var_name])
        except: b_orphan = 3
        if b_orphan<0: b_orphan=0
        r.set(orphan_var_name, b_orphan)
        r.set('r_size', len(result))


    def dtmlPrevBatch(self, text, start_var_name='b_start', size_var_name='b_size', orphan_var_name='b_orphan', classname="",showsteps=0, alt_text='', REQUEST=None):
        if hasattr(self,'REQUEST') or REQUEST is not None:
            r = self.REQUEST or REQUEST
            b_start = r[start_var_name]
            b_size = r[size_var_name]
            try: b_orphan = r[orphan_var_name]
            except: b_orphan = 3
            try: next_start = int(b_start) - int(b_size)
            except: next_start=1
            if b_start>1:
                appendgroupkeys = self.getSortLinkGroupsURLValues(exclude=[start_var_name],REQUEST=REQUEST,returnAsList=1)
                appendgroupkeys.append("%s=%s" % (start_var_name,str(next_start)))
                appendgroupkeys.reverse()
                if showsteps: text = text % b_size
                return """<a href="%s?%s" class="%s">%s</a>""" % (r['URL'], join(appendgroupkeys,'&'), classname, text)
            return alt_text
        raise "dtmlPrevBatch exception", "REQUEST not found"

    def dtmlNextBatch(self, text, start_var_name='b_start', size_var_name='b_size', orphan_var_name='b_orphan', classname="",showsteps=0, alt_text='', REQUEST=None):
        if hasattr(self,'REQUEST') or REQUEST is not None:
            r = self.REQUEST or REQUEST
            try: b_start = int(r[start_var_name])
            except: b_start=1
            try: b_size = int(r[size_var_name])
            except: b_size = 10
            try: b_orphan = int(r[orphan_var_name])
            except: b_orphan = 3
            if r.has_key('r_size'): r_size = r['r_size']
            else: r_size = None
            next_start = b_start + b_size
            if b_start+b_orphan>=r_size and b_start+b_size<r_size:
                next_size = r_size - next_start + 1
            else: next_size = b_size
            appendgroupkeys = self.getSortLinkGroupsURLValues(exclude=[start_var_name],REQUEST=REQUEST,returnAsList=1)
            appendgroupkeys.append("%s=%s" % (start_var_name,str(next_start)))
            appendgroupkeys.reverse()
            if showsteps: text = text % next_size
            if r_size and b_start+b_size<=r_size and b_start+b_orphan<=r_size:
                return """<a href="%s?%s" class="%s">%s</a>""" % (r['URL'], join(appendgroupkeys,'&'), classname, text)
            return alt_text
        raise "dtmlPrevBatch exception", "REQUEST not found"

    def dtmlBatchTotalSize(self,text, REQUEST=None, classname="tab-small"):
        if REQUEST is None: REQUEST = self.REQUEST
        text = text % REQUEST['r_size']
        return """<span class="%s">%s</span>""" % (classname,text)

    def dtmlBatchSize(self,text, REQUEST=None, size_var_name='b_size', classname="tab-small"):
        if REQUEST is None: REQUEST = self.REQUEST
        text = text % REQUEST[size_var_name]
        return """<span class="%s">%s</span>""" % (classname,text)

    def dtmlBatchPosition(self,text, REQUEST=None, start_var_name='b_start', classname="tab-small"):
        if REQUEST is None: REQUEST = self.REQUEST
        text = text % REQUEST[start_var_name]
        return """<span class="%s">%s</span>""" % (classname,text)


    def dtmlLinesInTextarea(self, data=(), structure='%(id)s:%(type)s=%(default)s'):
        result = ''
        start = 1
        for data_dict in data:
            if start:
                result = result + structure % data_dict
                start=0
            else:
                result = result + '\n' + structure % data_dict
        return result

    def js_encode(self, text, characters=("'",), marker=None):
        #Backwards compatable: marker was used as a single character to replace before.
        if marker is not None: characters=marker #Backwards compatable
        if type(characters) not in SeqvenceType: characters=[characters] #Backwards compatable
        text = replace(text,'\r',r'\r')
        text = replace(text,'\n',r'\n')
        text = replace(text, '"', r'\x22')
        for character in characters:
            escaped_character = "\\" + character
            text = replace(text, character, escaped_character)
        return text

    def safe_eval(self, expr, do_raise=0):
        try: return eval(expr, {}, {})
        except:
            if do_raise:
                raise "InvalidExpression", "The expression %s couldn't be evaluated." % expr
        return expr

    def multiLenghtSequence(self, seq):
        class Tmp:
            __allow_access_to_unprotected_subobjects__=1
            def __init__(self, dict=None):
                if type(dict) == DictType:
                    self.__dict__.update(dict)
        new_seq=[]
        for item in seq:
          if same_type(item, {}):
            new_seq.append(Tmp(item))
          elif (same_type(item, ()) or same_type(item, [])) and len(item)>1:
            new_seq.append(Tmp({'key':item[0],'label':item[1]}))
          elif (same_type(item, ()) or same_type(item, [])) and len(item)==1:
            new_seq.append(Tmp({'key':item[0],'label':item[0]}))
          else:
            new_seq.append(Tmp({'key':item,'label':item}))

        step, spill= divmod(100,len(new_seq))
        first=1
        for item in new_seq:
          if first:
            first=0
            item.width=str(step+spill)+'%'
          else:
            item.width=str(step)+'%'
        return new_seq

    def multiLenghtSequence(self, seq):
        class Tmp:
            __allow_access_to_unprotected_subobjects__=1
            def __init__(self, dict=None):
                if type(dict) == DictType:
                    self.__dict__.update(dict)
        new_seq=[]
        for item in seq:
          if same_type(item, {}):
            new_seq.append(Tmp(item))
          elif (same_type(item, ()) or same_type(item, [])) and len(item)>1:
            new_seq.append(Tmp({'key':item[0],'label':item[1]}))
          elif (same_type(item, ()) or same_type(item, [])) and len(item)==1:
            new_seq.append(Tmp({'key':item[0],'label':item[0]}))
          else:
            new_seq.append(Tmp({'key':item,'label':item}))

        step, spill= divmod(100,len(new_seq))
        first=1
        for item in new_seq:
          if first:
            first=0
            item.width=str(step+spill)+'%'
          else:
            item.width=str(step)+'%'
        return new_seq


    def strip_html(self, value):
        if type(value)<>StringType: value=str(value)
        return strip_html(value)

    def isEmpty(self, value, strip_html=1):
        if type(value)<>StringType: value=str(value)
        value=strip_html(value)
        return not not value.strip()



Globals.InitializeClass(EasyPresentationHelpers)

def initialize(context):
    """Initialize EasyPresentationHelpers Product"""
    pass

