# $Header: /usr/custom/cvs/public/EnergyPlusLive/lib/python/Products/EasyResources/EasyResource.py,v 1.6 2003/06/15 16:21:30 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#


__doc__='''EasyResources product: EasyResource base class.'''
__version__='1.8'

import Globals

from Products.EasyCatalog.EasyCatalogAware import EasyCatalogAware
from Products.EasyPresentationHelpers.EasyPresentationHelpers import EasyPresentationHelpers
from Products.EasyCore.VirtualPath import VirtualPathBase
from AccessControl import ClassSecurityInfo
from Products.EasyCore import EasyCorePermissions

from Products.EasyCore.EasyResourcesConf import RESOURCE_CATALOG_ID

class EasyResource(VirtualPathBase, EasyCatalogAware, EasyPresentationHelpers):
    """Adds some default properties function"""

    resource_catalog = RESOURCE_CATALOG_ID

    security = ClassSecurityInfo()

    __catalogs__=(RESOURCE_CATALOG_ID,)

    isAnObjectManager = 0
    hasSubDocuments = 0

    security.declarePrivate('manage_afterClone')
    def manage_afterClone(self, item):
        EasyResource.inheritedAttribute('manage_afterClone')(self, item)

    security.declarePrivate('manage_afterAdd')
    def manage_afterAdd(self, item, container):
        EasyResource.inheritedAttribute('manage_afterAdd')(self, item, container)

    security.declarePrivate('manage_beforeDelete')
    def manage_beforeDelete(self, item, container):
        EasyResource.inheritedAttribute('manage_beforeDelete')(self, item, container)


Globals.InitializeClass(EasyResource)



