# $Header: /usr/custom/cvs/public/EnergyPlusLive/lib/python/Products/EasySecurity/EasySecurityExpire.py,v 1.3 2003/04/14 12:37:35 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#

__doc__ = """EasyPublisher system: EasyExpireUser and EasyExpireUserFolder classes."""
__version__='$Revision: 1.3 $'[11:-2]


#EasySecurityExpire
#TODO: Verify email adress

from Globals import DTMLFile, MessageDialog
from AccessControl.User import UserFolder, User, reqattr, BasicUserFolder
from AccessControl import ClassSecurityInfo
from Products.EasyCore import EasyCorePermissions

class EasyExpireUserFolder(UserFolder):
    """ EasyExpireUserFolder and EasyExpireUser is a normal user that has an email adress and full name.
        It's an ugly hack, that should be replaced with something better and flexible.
    """
    meta_type = "EasyExpireUserFolder"

    title    ='EasyExpireUserFolder'

    isEasyUserFolder = 1

    security = ClassSecurityInfo()

    __ac_permissions__ = UserFolder.__ac_permissions__

    _editUser=DTMLFile('dtml/editUser', globals(),
                       remote_user_mode__=0)
    _add_User=DTMLFile('dtml/addUser', globals(),
                       remote_user_mode__=0)

    def _doAddUser(self, name, password, roles, domains):
        """Create a new user"""
        self.data[name]=EasyExpireUser(name,password,roles,domains)

    security.declareProtected(EasyCorePermissions.ManageUsers, 'manage_users')
    def manage_users(self,submit=None,REQUEST=None,RESPONSE=None):
        """ """

        # Set the email and fullname:
        if (submit=='Edit'):
            name = reqattr(REQUEST, 'name')
            user=self.data[name]
            REQUEST.set('email',user.ec_email)
            REQUEST.set('fullname',user.ec_fullname)
            return UserFolder.manage_users(self,submit=submit,REQUEST=REQUEST,RESPONSE=RESPONSE)

        if (submit=='Delete') or (submit=='Add...'):
            return UserFolder.manage_users(self,submit=submit,REQUEST=REQUEST,RESPONSE=RESPONSE)

        # Change the email and fullname:
        if (submit=='Add') or (submit=='Change'):
            returnresult = UserFolder.manage_users(self,submit=submit,REQUEST=REQUEST,RESPONSE=RESPONSE)
            #NB! This must be done after the UserFolder.manage_users for 'Add' or there is no user to look up.
            name = reqattr(REQUEST, 'name')
            user=self.data[name]
            REQUEST.set('email',user.ec_email)
            REQUEST.set('fullname',user.ec_fullname)

            user.ec_email = reqattr(REQUEST, 'ec_email')
            user.ec_fullname = reqattr(REQUEST, 'ec_fullname')
            self.data[name] = user
            return returnresult

        # Unknown submit request:
        return UserFolder.manage_users(self,submit=submit,REQUEST=REQUEST,RESPONSE=RESPONSE)

Globals.InitializeClass(EasyExpireUserFolder)

class EasyExpireUser(User):
    """User with email. """

    security = ClassSecurityInfo()

    meta_type = "EasyExpireUser"

    def __init__(self,name,password,roles,domains):
        self.name   =name
        self.__     =password
        self.roles  =roles
        self.domains=domains
        self.ec_email=''
        self.ec_fullname=''

Globals.InitializeClass(EasyExpireUser)

def manage_addEasyExpireUserFolder(self,dtself=None,REQUEST=None,**ignored):
    """ """
    f=EasyExpireUserFolder()
    self=self.this()
    if 'acl_users' in self.objectIds():
        #This should be a smarter migration at least for regulare Zope UserFolder
        if not hasattr(self._getOb('acl_users'),'isEasyUserFolder'):
            from zLOG import LOG, WARNING
            LOG('EasyEditor', WARNING, 'registerViewDefault', "Has user folder but it's not EasyExpireUserFolder so we *brutally* delete it...\n")
            self._delObject('acl_users')
    try:
        self._setObject('acl_users', f)
    except:
        return MessageDialog(
                   title  ='Item Exists',
                   message='This object already contains a User Folder',
                   action ='%s/manage_main' % REQUEST['URL1'])
    self.__allow_groups__=f
    get_transaction().note('Installed a EasyExpireUserFolder.')
    get_transaction().commit()
    if REQUEST is not None:
        REQUEST['RESPONSE'].redirect(self.absolute_url()+'/manage_main')


def initialize(context):
    """Initialize Products"""

    context.registerClass(
        EasyExpireUserFolder,
        permission=EasyUserFolderServiceAdd,
        #icon='images/EasyDocument.gif',
        constructors=(manage_addEasyExpireUserFolder,),
        meta_type = 'EasyExpireUserFolder'
    )
