# $Header: /usr/custom/cvs/public/EnergyPlusLive/lib/python/Products/ObjectRepository/SQLDataTypes.py,v 1.3 2003/06/24 17:19:37 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#


from Persistence import Persistent
from DateTime import DateTime
from Products.PluginIndexes.FieldIndex.FieldIndex import FieldIndex
from Products.PluginIndexes.TextIndex.TextIndex import TextIndex
from Products.PluginIndexes.DateIndex.DateIndex import DateIndex
from Products.PluginIndexes.DateRangeIndex.DateRangeIndex import DateRangeIndex
from Products.PluginIndexes.TopicIndex.TopicIndex import TopicIndex
from Products.PluginIndexes.KeywordIndex.KeywordIndex import KeywordIndex
from Products.PluginIndexes.PathIndex.PathIndex import PathIndex



class Varchar(Persistent):
    """\
    varchar(size)

    Holds a variable length string (can contain letters, numbers,
    and special characters).
    The maximum size is specified in parenthesis.
    """

    def __init__(self, size=65535):
        self.size=size

Text=Varchar

class Char(Persistent):
    """\
    char(size)

    Holds a fixed length string (can contain letters, numbers,
    and special characters).
    The fixed size is specified in parenthesis.
    """

    def __init__(self, size=256):
        self.size=size

class Integer(Persistent):
    """\
    integer(size)

    Hold integers only. The maximum number of digits are specified in parenthesis.

    Use python long.
    """
    def __init__(self, size=256):
        self.size=size

class Int(Persistent):
    """\
    int(size)

    Hold integers only. The maximum number of digits are specified in parenthesis.
    Use python int.
    """
    def __init__(self, size=256):
        self.size=size

class Smallint(Persistent):
    """\
    Smallint(size)

    Hold integers only. The maximum number of digits are specified in parenthesis.
    Use python int.
    """
    def __init__(self, size=256):
        self.size=size

class Tinyint(Persistent):
    """\
    tinyint(size)

    Hold integers only. The maximum number of digits are specified in parenthesis.
    Use python int.
    """
    def __init__(self, size=256):
        self.size=size

class Decimal(Persistent):
    """\
    decimal(size,d)

    Hold numbers with fractions. The maximum number of digits
    are specified in "size". The maximum number of digits to
    the right of the decimal is specified in "d".
    """
    def __init__(self, size=10, d=2):
        self.size=size
        self.d=d


Float=Decimal

class Numeric(Persistent):
    """\
    numeric(size,d)

    Hold numbers with fractions. The maximum number of digits
    are specified in "size". The maximum number of digits to
    the right of the decimal is specified in "d".
    """
    def __init__(self, size=10, d=2):
        self.size=size
        self.d=d


class Date(Persistent):
    """\
    date(yyyymmdd)

    A date
    """
    def __init__(self, date_string):
        self.date_string=date_string


class DateTime(Persistent):
    """\
    datetime(yyyymmdd hh:m:ss TZ)

    Date and time
    """
    def __init__(self, date_time, timezone=None):
        self.date_time=date_time


##INTEGER A whole number
##VARCHAR(10) Up to 10 characters.
##CHAR(10)    Fixed number of characters
##DATE    A date
##DATETIME    Date and time
##FLOAT   Floating point numbers (do not use this for money)
##mysql variations:
##TEXT    Allows up to 65535 characters
##DECIMAL(10,2)   Up to 10 digits before the point, 2 after.