#####################################################################
#
# Xron -- Zope Scheduled Event Product
# Copyright (C) 2000 Loren Stafford
#
# Derived from the ZScheduler product version 0.0.7 in accord
# with the terms of the ZScheduler's license.
#
# Based on code by Martijn Pieters, (c) 1999 Antraciet B.V.
# Used with explicit permission.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.    See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the
#         Free Software Foundation, Inc.,
#         59 Temple Place - Suite 330,
#         Boston, MA    02111-1307, USA.
#
#####################################################################
""" Scheduled DTML Methods for Xron """

from Globals import DTMLFile, InitializeClass
from DateTime import DateTime
from OFS.DTMLMethod import DTMLMethod
from AccessControl import ClassSecurityInfo
from Products.ZCatalog.CatalogAwareness import CatalogAware
from urllib import quote
import string

import Schedule
ScheduleID=Schedule.ScheduleID

#import pdb; pdb.set_trace()

from Products.Xron.XronBase import XronBase

default_event_html = 'Content-type: text/plain\n\n'

class XronDTMLMethod(XronBase, DTMLMethod):

    meta_type = 'Xron DTML Method'
    security = ClassSecurityInfo()


    manage_options= DTMLMethod.manage_options[0:1]+XronBase.manage_options[0:2] + DTMLMethod.manage_options[1:]

    def __init__(self, id, title = ''
                , periodyears=0
                , periodmonths=0
                , perioddays=0
                , periodhours=0
                , periodminutes=0
                , periodweeks=0
                , start=None
                , file = ''):
        XronBase.__init__(self, id, title
                        , periodyears=periodyears
                        , periodmonths=periodmonths
                        , perioddays=perioddays
                        , periodhours=periodhours
                        , periodminutes=periodminutes
                        , periodweeks=periodweeks
                        , start=start)
        DTMLMethod.__init__(self, file, __name__ = id)
        self.title = title

    def do_trigger(self, **kw):
        print "XronDTMLMethod", self.next_update


InitializeClass(XronDTMLMethod)

manage_addXronDTMLMethodForm =     DTMLFile('dtml/manage_addXronDTMLMethodForm', globals())

def manage_addXronDTMLMethod(self, id, title = '', file = ''
                            , periodyears=0
                            , periodmonths=0
                            , perioddays=0
                            , periodhours=0
                            , periodminutes=0
                            , periodweeks=0
                            , start=None
                            , REQUEST = None, submit = None):
    """Add an XronDTMLMethod object with the contents of file.
    If 'file' is empty, default document text is used.
    """
    if type(file) is not type(''): file = file.read()
    if not file: file = default_event_html
    event=XronDTMLMethod( id, title, file
                            , periodyears=periodyears
                            , periodmonths=periodmonths
                            , perioddays=perioddays
                            , periodhours=periodhours
                            , periodminutes=periodminutes
                            , periodweeks=periodweeks
                            , start=start)
    id=self._setObject(id, event)
    if REQUEST is not None:
        try: u=self.DestinationURL()
        except: u=REQUEST['URL1']
        if submit==" Add and Edit ": u="%s/%s" % (u,quote(id))
        REQUEST.RESPONSE.redirect(u+'/manage_main')
    return ''

