from zLOG import LOG, INFO, BLATHER

LOG('ZMIPatch', BLATHER, 'ZMI Patch:AccessControl', """Hotfixing: AccessControl: Extending Local Roles,
           Johan Carlsson, 2001-10-04, version Easy Publisher 1.8\n""")


from AccessControl.Role import RoleManager
from AccessControl.User import BasicUser
import Globals
from Globals import DTMLFile
from App.Common import aq_base
from string import join, find, replace
from AccessControl import ClassSecurityInfo
from urllib import quote
from re import compile

from Products.EasyCore.BodyTabs import InitializeBodyTabs, UpdateTab


from zLOG import LOG

securityRoleManager = ClassSecurityInfo()

# Local roles support
# -------------------
#
# Local roles allow a user to be given extra roles in the context
# of a particular object (and its children). When a user is given
# extra roles in a particular object, an entry for that user is made
# in the __ac_local_roles__ dict containing the extra roles.

#__ac_local_roles__=None

#TODO: New methods need to have "Change permissions" premissions defined for them

__ac_local_roles_white__ = {}
__ac_local_roles_black__ = {}
RoleManager.__ac_local_roles_white__ = __ac_local_roles_white__
RoleManager.__ac_local_roles_black__ = __ac_local_roles_black__

manage_listLocalRoles=DTMLFile('dtml/listLocalRoles', globals(),
               management_view='Security',
               help_topic='Security_Local-Roles.stx',
               help_product='OFSP'
             , body_tab={'label':'Local Roles','order':2, 'management_view':'Security', 'url':'manage_listLocalRoles'}
             )

RoleManager.manage_listLocalRoles = manage_listLocalRoles

manage_editLocalRoles=DTMLFile('dtml/editLocalRoles', globals(),
               management_view='Security',
               help_topic='Security_User-Local-Roles.stx',
               help_product='OFSP'
             , body_tab={'label':'Local Roles','order':2, 'management_view':'Security', 'url':'manage_listLocalRoles'}
             )


RoleManager.manage_editLocalRoles = manage_editLocalRoles



def has_local_roles(self):
    if not callable(self.__ac_local_roles__): del self.__ac_local_roles__
    dict=self.__ac_local_roles__()
    return len(dict)

RoleManager.has_local_roles = has_local_roles

def get_local_roles(self):
    if not callable(self.__ac_local_roles__): del self.__ac_local_roles__
    dict=self.__ac_local_roles__()
    keys=dict.keys()
    keys.sort()
    info=[]
    for key in keys:
        value=tuple(dict[key])
        info.append((key, value))
    return tuple(info)

RoleManager.get_local_roles = get_local_roles

def get_valid_userids(self):
    item=self
    dict={}
    _notfound = []
    while 1:
        #__allow_groups__/acl_users
        aclu = getattr(aq_base(item), '__allow_groups__', _notfound)
        if aclu is not _notfound and hasattr(aclu, 'user_names'):
            for name in aclu.user_names():
                dict[name]=1
        if not hasattr(item, 'aq_parent'):
            break
        item=item.aq_parent
    keys=dict.keys()
    keys.sort()
    return tuple(keys)

RoleManager.get_valid_userids = get_valid_userids

#Search Interface for acl_users
def search_valid_userids(self, query=(),show_all=0):
    if query==(): return ()
    if type(query)==type(''): query=(query,)
    lquery=map(lambda x: replace(x, '*', '.*'), query)
    re_str=join(map(lambda x: '(^%s.*$)' % x, lquery),'|')
    re_query=compile(re_str)
    item=self
    dict={}
    while 1:
        if hasattr(aq_base(item), 'acl_users') and \
           hasattr(item.acl_users, 'user_names'):
            for name in item.acl_users.user_names():
                if re_query.match(name):
                    if not show_all and name not in self.__ac_local_roles_white__.keys():
                        dict[name]=1
        if not hasattr(item, 'aq_parent'):
            break
        item=item.aq_parent
    keys=dict.keys()
    keys.sort()
    return tuple(keys)

securityRoleManager.declarePrivate('search_valid_userids')
RoleManager.search_valid_userids = search_valid_userids

def manage_addLocalUsers(self, userids=(), roles=(), REQUEST=None, RESPONSE=None):
    """Add users to local roles."""
    if not callable(self.__ac_local_roles__): del self.__ac_local_roles__
    dict=self.__ac_local_roles__()
    for userid in userids:
        dict[userid]=roles
    self.setLocalRoles(dict)
    if REQUEST and RESPONSE:
        if roles: roles_message=" with the roles [%s]" % (join(roles,', '),)
        else: roles_message=""
        message="Users [%s] has been added%s." % (join(userids,', '),roles_message)
        RESPONSE.redirect('%s/manage_listLocalRoles?manage_tabs_message=%s' % (REQUEST.URL1, quote(message)))

securityRoleManager.declareProtected('Change permissions', 'manage_addLocalUsers')
RoleManager.manage_addLocalUsers = manage_addLocalUsers

def manage_delLocalUsers(self, userids=(), REQUEST=None, RESPONSE=None):
    """Remove users from local roles."""
    local_roles_white = getattr(self.aq_base,'__ac_local_roles_white__',{})
    local_roles_black = getattr(self.aq_base,'__ac_local_roles_black__', {})
    for userid in userids:
        if local_roles_black.has_key(userid):
            del local_roles_black[userid]
        if local_roles_white.has_key(userid):
            del local_roles_white[userid]
    self.setLocalRoles(local_roles_white)
    self.setLocalRolesBlack(local_roles_black)
    if REQUEST and RESPONSE:
        message="Local users [%s] has been removed." % (join(userids,', '),)
        RESPONSE.redirect('%s/manage_listLocalRoles?manage_tabs_message=%s' % (REQUEST.URL1, quote(message)))

securityRoleManager.declareProtected('Change permissions', 'manage_delLocalUsers')
RoleManager.manage_delLocalUsers = manage_delLocalUsers



def get_local_roles_for_userid(self, userid):
    #PATCH: temporary patch code
    if not callable(self.__ac_local_roles__): del self.__ac_local_roles__
    dict=self.__ac_local_roles__()
    return tuple(dict.get(userid, []))

RoleManager.get_local_roles_for_userid = get_local_roles_for_userid

def manage_addLocalRoles(self, userid, roles, REQUEST=None, RESPONSE=None):
    """Set local roles for a user."""
    if not roles:
        raise ValueError, 'One or more roles must be given!'
    if not callable(self.__ac_local_roles__): del self.__ac_local_roles__
    dict=self.__ac_local_roles__()
    local_roles = list(dict.get(userid, []))
    for r in roles:
        if r not in local_roles:
            local_roles.append(r)
    dict[userid] = local_roles
    self.setLocalRoles(dict)
    if REQUEST and RESPONSE:
        message="User [%s] has been added with the roles [%s]." % (userid,join(roles,', '))
        RESPONSE.redirect('%s/manage_listLocalRoles?manage_tabs_message=%s' % (REQUEST.URL1, quote(message)))

RoleManager.manage_addLocalRoles = manage_addLocalRoles

def manage_setLocalRoles(self, userid, roles, REQUEST=None, RESPONSE=None):
    """Set local roles for a user."""
    if not roles:
        raise ValueError, 'One or more roles must be given!'
    if not callable(self.__ac_local_roles__): del self.__ac_local_roles__
    dict=self.__ac_local_roles__()
    dict[userid]=roles
    self.setLocalRoles(dict)
    if REQUEST and RESPONSE:
        message="The local roles [%s] has been added to the user [%s]." % (join(roles,', '),userid)
        RESPONSE.redirect('%s/manage_listLocalRoles?manage_tabs_message=%s' % (REQUEST.URL1, quote(message)))

RoleManager.manage_setLocalRoles = manage_setLocalRoles

def manage_delLocalRoles(self, userids, REQUEST=None, RESPONSE=None):
    """Remove local users."""
    if not callable(self.__ac_local_roles__): del self.__ac_local_roles__
    dict=self.__ac_local_roles__()
    for userid in userids:
        if dict.has_key(userid):
            del dict[userid]
    self.setLocalRoles(dict)
    if REQUEST and RESPONSE:
        message="The local users [%s] has been removed." % (join(userids,', '))
        RESPONSE.redirect('%s/manage_listLocalRoles?manage_tabs_message=%s' % (REQUEST.URL1, quote(message)))

RoleManager.manage_delLocalRoles = manage_delLocalRoles



def __ac_local_roles__(self):
    local_roles = self.__ac_local_roles_white__ or {}
    local_roles = local_roles.copy()
    black = self.__ac_local_roles_black__ or {}
    blackusers = black.keys()
    for user, roles in local_roles.items():
        if user in blackusers:
            local_roles[user] = filter(lambda r, br=black[user]: r not in br, roles)
    return local_roles

RoleManager.__ac_local_roles__ = __ac_local_roles__


securityRoleManager.declarePrivate('setLocalRoles')
def setLocalRoles(self, local_roles_white):
    self.__ac_local_roles_white__=local_roles_white

RoleManager.setLocalRoles = setLocalRoles


securityRoleManager.declarePrivate('setLocalRolesBlack')
def setLocalRolesBlack(self, local_roles_black):
    self.__ac_local_roles_black__=local_roles_black

securityRoleManager.declarePrivate('getBlackRolesForUser')
def getBlackRolesForUser(self, user):
    return self.__ac_local_roles_black__.get(user, ())

securityRoleManager.declarePrivate('getBlackList')
def getBlackList(self, user):
    return self.__ac_local_roles_black__

RoleManager.setLocalRolesBlack = setLocalRolesBlack
RoleManager.getBlackRolesForUser = getBlackRolesForUser
RoleManager.getBlackList = getBlackList


# local_roles_with_hop
# {
#   'user1': {role1: hop0, role2: hop1, role3: hop0 },
#   'user2': {role1: hop1, role2: hop1, role3: hop1 },
# }

securityRoleManager.declarePrivate('get_local_roles_aq')
def get_local_roles_aq(self):
    hop=-1
    local_roles = {}
    black_roles = {}
    inner_obj = getattr(self, 'aq_inner', self)
    while 1:
        hop=hop + 1
        current_local_roles = getattr(inner_obj,'__ac_local_roles_white__',None)
        current_black_roles = getattr(inner_obj,'__ac_local_roles_black__',None)
        if current_black_roles is not None:
            for user, roles in current_black_roles.items():
                if not black_roles.has_key(user):
                    black_roles[user] = ()
                black_roles[user] = black_roles[user] + roles
        if current_local_roles is not None:
            for user, roles in current_local_roles.items():
                if not local_roles.has_key(user):
                  local_roles[user] = {}
                b_roles = black_roles.get(user, ())
                for role in roles:
                    if (role not in local_roles[user].keys()) and (role not in b_roles):
                        local_roles[user][role] = hop
        inner = getattr(inner_obj, 'aq_inner', inner_obj)
        parent = getattr(inner, 'aq_parent', None)
        if parent is not None:
            inner_obj = parent
            continue
        if hasattr(inner_obj, 'im_self'):
            inner_obj=inner_obj.im_self
            inner_obj=getattr(inner_obj, 'aq_inner', inner_obj)
            continue
        break
    return local_roles

RoleManager.get_local_roles_aq = get_local_roles_aq

def isLocalUser(self,userid):
    return self.__ac_local_roles_white__.has_key(userid)

securityRoleManager.declarePrivate('isLocalUser')
RoleManager.isLocalUser = isLocalUser

securityRoleManager.declarePrivate('filter_acquired_roles_for_userid')
def filter_acquired_roles_for_userid(self, userid, local_roles_with_hop=None):
    if local_roles_with_hop is None: local_roles_with_hop= {}
    if local_roles_with_hop.has_key(userid):
        return map(lambda (role, hop): role,filter(lambda (role, hop): hop!=0, local_roles_with_hop[userid].items()))
    return []

RoleManager.filter_acquired_roles_for_userid = filter_acquired_roles_for_userid

securityRoleManager.declarePrivate('getUserById')
def getUserById(self, userid):
    item=self
    while 1:
        if hasattr(aq_base(item), 'acl_users') and \
           hasattr(item.acl_users, 'user_names'):
            for name in item.acl_users.user_names():
                if userid == name:
                    #The User object needs to be in the context of the
                    #user folder that contains it.
                    return item.acl_users.getUser(userid).__of__(item.acl_users)
        if not hasattr(item, 'aq_parent'):
            break
        item=item.aq_parent
    return None

RoleManager.getUserById = getUserById


securityRoleManager.declareProtected('Change permissions', 'manage_addLocalRolesForUsers')
def manage_addLocalRolesForUsers(self, userids=None, roles=None, REQUEST=None, RESPONSE=None):
    """Add Local Users"""
    if roles is None: roles=[]
    if userids is None: userids=[]
    local_roles_white = getattr(self.aq_base,'__ac_local_roles_white__', {})
    for user in userids:
        try: users_white_roles = list(local_roles_white[user])
        except: users_white_roles = []
        for role in roles:
            if role not in users_white_roles: users_white_roles.append(role)
            local_roles_white[user] = tuple(users_white_roles)
    self.setLocalRoles(local_roles_white)
    if REQUEST and RESPONSE:
        message="[%s] has been blacklisted as [%s]." % (join(userids,', '),join(roles,', '))
        RESPONSE.redirect('%s/manage_listLocalRoles?manage_tabs_message=%s' % (REQUEST.URL1, quote(message)))

RoleManager.manage_addLocalRolesForUsers = manage_addLocalRolesForUsers

securityRoleManager.declareProtected('Change permissions', 'manage_delLocalRolesForUsers')
def manage_delLocalRolesForUsers(self, userids=None, roles=None, REQUEST=None, RESPONSE=None):
    """Delete Local Users"""
    if roles is None: roles=[]
    if userids is None: userids=[]
    local_roles_white = getattr(self.aq_base,'__ac_local_roles_white__', {})
    local_roles_black = getattr(self.aq_base,'__ac_local_roles_black__', {})
    for user in userids:
        try: users_white_roles = list(local_roles_white[user])
        except: users_white_roles = ()
        for role in roles:
            if role in users_white_roles: users_white_roles.remove(role)
            local_roles_white[user] = tuple(users_white_roles)
    self.setLocalRoles(local_roles_white)
    if REQUEST and RESPONSE:
        message="[%s] has been given the role(s): [%s]." % (join(userids, ', '),join(roles, ', '))
        RESPONSE.redirect('%s/manage_listLocalRoles?manage_tabs_message=%s' % (REQUEST.URL1, quote(message)))

RoleManager.manage_delLocalRolesForUsers = manage_delLocalRolesForUsers

securityRoleManager.declareProtected('Change permissions', 'manage_addUsersToBlackList')
def manage_addUsersToBlackList(self, userids=None, roles=None, REQUEST=None, RESPONSE=None):
    """Disable users from Local Role Access"""
    if roles is None: roles=[]
    if userids is None: userids=[]
    local_roles_black = getattr(self.aq_base,'__ac_local_roles_black__', {})
    for user in userids:
        users_black_roles = list(local_roles_black.get(user,()))
        for role in roles:
            if role not in users_black_roles: users_black_roles.append(role)
        if users_black_roles==[]:
            if local_roles_black.has_key(user):
                del local_roles_black[user]
        else:
            local_roles_black[user] = tuple(users_black_roles)
    self.setLocalRolesBlack(local_roles_black)
    if REQUEST and RESPONSE:
        message="[%s] has been removed as local role(s): [%s]."  % (join(userids, ', '),join(roles, ', '))
        RESPONSE.redirect('%s/manage_listLocalRoles?manage_tabs_message=%s' % (REQUEST.URL1, quote(message)))

RoleManager.manage_addUsersToBlackList = manage_addUsersToBlackList

securityRoleManager.declareProtected('Change permissions', 'manage_removeUsersToBlackList')
def manage_removeUsersToBlackList(self, userids=None, roles=None, REQUEST=None, RESPONSE=None):
    """Enable disabled users from Local Role Access"""
    if roles is None: roles=[]
    if userids is None: userids=[]
    local_roles_black = getattr(self.aq_base,'__ac_local_roles_black__', {})
    for user in userids:
        users_black_roles = list(local_roles_black.get(user,()))
        for role in roles:
            if role in users_black_roles: users_black_roles.remove(role)
        if users_black_roles==[]:
            if local_roles_black.has_key(user):
                del local_roles_black[user]
        else:
            local_roles_black[user] = tuple(users_black_roles)
            #local_roles_black[user] = tuple(users_black_roles)
    self.setLocalRolesBlack(local_roles_black)
    if REQUEST and RESPONSE:
        message="[%s] has been enabled as [%s]." % (join(userids,', '),join(roles,', '))
        RESPONSE.redirect('%s/manage_listLocalRoles?manage_tabs_message=%s' % (REQUEST.URL1, quote(message)))

RoleManager.manage_removeUsersToBlackList = manage_removeUsersToBlackList


RoleManager.security = securityRoleManager
Globals.InitializeClass(RoleManager)


# ==============================================================================
# PATCH OF AccessControl.User.py

securityBasicUser = ClassSecurityInfo()

def getRolesInContext(self, object):
    """
    Return the list of roles assigned to the user,
    including local roles assigned in context of
    the passed in object.
    """
    userid=self.getId()
    roles=self.getRoles()
    black_roles = ()
    inner_obj = getattr(object, 'aq_inner', object)
    while 1:
        current_local_roles = getattr(inner_obj,'__ac_local_roles_white__',None)
        current_black_roles = getattr(inner_obj,'__ac_local_roles_black__',None)
        if current_black_roles is not None:
            black_roles = black_roles + current_black_roles.get(userid, ())
        if current_local_roles is not None:
            for local_role in current_local_roles.get(userid, ()):
                if (local_role not in roles) and (local_role not in black_roles):
                    roles = roles + (local_role,)
        inner = getattr(inner_obj, 'aq_inner', inner_obj)
        parent = getattr(inner, 'aq_parent', None)
        if parent is not None:
            inner_obj = parent
            continue
        if hasattr(inner_obj, 'im_self'):
            inner_obj=inner_obj.im_self
            inner_obj=getattr(inner_obj, 'aq_inner', inner_obj)
            continue
        break
    return roles

BasicUser.getRolesInContext = getRolesInContext

def allowed(self, object, object_roles=None):
    """Check whether the user has access to object. The user must
       have one of the roles in object_roles to allow access."""

    # Short-circuit the common case of anonymous access.
    if object_roles is None or 'Anonymous' in object_roles:
        return 1

    # Check for ancient role data up front, convert if found.
    # This should almost never happen, and should probably be
    # deprecated at some point.
    if 'Shared' in object_roles:
        object_roles = self._shared_roles(object)
        if object_roles is None or 'Anonymous' in object_roles:
            return 1

    # Check for a role match with the normal roles given to
    # the user, then with local roles only if necessary. We
    # want to avoid as much overhead as possible.
    user_roles = self.getRoles()
    for role in object_roles:
        if role in user_roles:
            if self._check_context(object):
                return 1
            return None

    # Still have not found a match, so check local roles. We do
    # this manually rather than call getRolesInContext so that
    # we can incur only the overhead required to find a match.

    inner_obj = getattr(object, 'aq_inner', object)
    userid=self.getId()
    black_roles = ()
    while 1:
        current_local_roles = getattr(inner_obj,'__ac_local_roles_white__',None)
        current_black_roles = getattr(inner_obj,'__ac_local_roles_black__',None)
        if current_black_roles is not None:
            black_roles = black_roles + current_black_roles.get(userid, ())
        if current_local_roles is not None:
            local_roles = current_local_roles.get(userid, [])
            for role in object_roles:
                if role in local_roles and role not in black_roles:
                    if self._check_context(object):
                        return 1
                    return None
        inner = getattr(inner_obj, 'aq_inner', inner_obj)
        parent = getattr(inner, 'aq_parent', None)
        if parent is not None:
            inner_obj = parent
            continue
        if hasattr(inner_obj, 'im_self'):
            inner_obj=inner_obj.im_self
            inner_obj=getattr(inner_obj, 'aq_inner', inner_obj)
            continue
        break
    return None

BasicUser.allowed = allowed

BasicUser.security = securityBasicUser
Globals.InitializeClass(BasicUser)

from App.version_txt import getZopeVersion
zope_version=getZopeVersion()
LOG('ZMIPatch', 0, "RoleManager:zope_version: %s" % '-'.join(map(str, zope_version)) )


if zope_version[0:3]>=(2,7,0) and zope_version[0:3] < (2,8,0):

    security = ClassSecurityInfo()
    RoleManager.manage_roleForm=DTMLFile('dtml/Zope270/roleEdit', globals()
                            , management_view='Security'
                            , help_topic='Security_Manage-Role.stx'
                            , help_product='OFSP'
                            , body_tab={'label':'Permissions','order':1, 'management_view':'Security'}
                            )
    RoleManager.manage_acquiredForm=DTMLFile('dtml/Zope270/acquiredEdit', globals()
                            , management_view='Security'
                            , help_topic='Security_Manage-Acquisition.stx'
                            , help_product='OFSP'
                            , body_tab={'label':'Permissions','order':1, 'management_view':'Security'}
                            )

    RoleManager.manage_permissionForm=DTMLFile('dtml/Zope270/permissionEdit', globals()
                            , management_view='Security'
                            , help_topic='Security_Manage-Permission.stx'
                            , help_product='OFSP'
                            , body_tab={'label':'Permissions','order':1, 'management_view':'Security'}
                            )

    RoleManager._normal_manage_access=DTMLFile('dtml/Zope270/access', globals()
                            , management_view='Security'
                            , body_tab={'label':'Permissions','order':1, 'management_view':'Security', 'url':'manage_access'}
                            )

    RoleManager._method_manage_access=DTMLFile('dtml/Zope270/methodAccess', globals()
                            , management_view='Security'
                            , body_tab={'label':'Permissions','order':1, 'management_view':'Security', 'url':'manage_access'}
                            )


    RoleManager.security=security
    Globals.InitializeClass(RoleManager)
    InitializeBodyTabs(RoleManager)

elif zope_version[0:3]>=(2,6,1) and zope_version[0:3] < (2,7,0):

    security = ClassSecurityInfo()
    RoleManager.manage_roleForm=DTMLFile('dtml/Zope261/roleEdit', globals()
                            , management_view='Security'
                            , help_topic='Security_Manage-Role.stx'
                            , help_product='OFSP'
                            , body_tab={'label':'Permissions','order':1, 'management_view':'Security'}
                            )
    RoleManager.manage_acquiredForm=DTMLFile('dtml/Zope261/acquiredEdit', globals()
                            , management_view='Security'
                            , help_topic='Security_Manage-Acquisition.stx'
                            , help_product='OFSP'
                            , body_tab={'label':'Permissions','order':1, 'management_view':'Security'}
                            )

    RoleManager.manage_permissionForm=DTMLFile('dtml/Zope261/permissionEdit', globals()
                            , management_view='Security'
                            , help_topic='Security_Manage-Permission.stx'
                            , help_product='OFSP'
                            , body_tab={'label':'Permissions','order':1, 'management_view':'Security'}
                            )

    RoleManager._normal_manage_access=DTMLFile('dtml/Zope261/access', globals()
                            , management_view='Security'
                            , body_tab={'label':'Permissions','order':1, 'management_view':'Security', 'url':'manage_access'}
                            )

    RoleManager._method_manage_access=DTMLFile('dtml/Zope261/methodAccess', globals()
                            , management_view='Security'
                            , body_tab={'label':'Permissions','order':1, 'management_view':'Security', 'url':'manage_access'}
                            )


    RoleManager.security=security
    Globals.InitializeClass(RoleManager)
    InitializeBodyTabs(RoleManager)

elif zope_version[0:3]>=(2,5,1) and zope_version[0:3] < (2,6,1):

    security = ClassSecurityInfo()
    RoleManager.manage_roleForm=DTMLFile('dtml/Zope251/roleEdit', globals()
                             , management_view='Security'
                             , help_topic='Security_Manage-Role.stx'
                             , help_product='OFSP'
                             , body_tab={'label':'Permissions','order':1, 'management_view':'Security'}
                            )
    RoleManager.manage_acquiredForm=DTMLFile('dtml/Zope251/acquiredEdit', globals()
                            , management_view='Security'
                            , help_topic='Security_Manage-Acquisition.stx'
                            , help_product='OFSP'
                            , body_tab={'label':'Permissions','order':1, 'management_view':'Security'}
                            )

    RoleManager.manage_permissionForm=DTMLFile('dtml/Zope251/permissionEdit', globals()
                            , management_view='Security'
                            , help_topic='Security_Manage-Permission.stx'
                            , help_product='OFSP'
                            , body_tab={'label':'Permissions','order':1, 'management_view':'Security'}
                            )

    RoleManager._normal_manage_access=DTMLFile('dtml/Zope251/access', globals()
                            , management_view='Security'
                            , body_tab={'label':'Permissions','order':1, 'management_view':'Security', 'url':'manage_access'}
                            )

    RoleManager._method_manage_access=DTMLFile('dtml/Zope251/methodAccess', globals()
                            , management_view='Security'
                            , body_tab={'label':'Permissions','order':1, 'management_view':'Security', 'url':'manage_access'}
                            )

    RoleManager.security=security
    Globals.InitializeClass(RoleManager)
    InitializeBodyTabs(RoleManager)

else:

    security = ClassSecurityInfo()
    RoleManager.manage_roleForm=DTMLFile('dtml/Zope261/roleEdit', globals()
                            , management_view='Security'
                            , help_topic='Security_Manage-Role.stx'
                            , help_product='OFSP'
                            , body_tab={'label':'Permissions','order':1, 'management_view':'Security'}
                            )
    RoleManager.manage_acquiredForm=DTMLFile('dtml/Zope261/acquiredEdit', globals()
                            , management_view='Security'
                            , help_topic='Security_Manage-Acquisition.stx'
                            , help_product='OFSP'
                            , body_tab={'label':'Permissions','order':1, 'management_view':'Security'}
                            )

    RoleManager.manage_permissionForm=DTMLFile('dtml/Zope261/permissionEdit', globals()
                            , management_view='Security'
                            , help_topic='Security_Manage-Permission.stx'
                            , help_product='OFSP'
                            , body_tab={'label':'Permissions','order':1, 'management_view':'Security'}
                            )

    RoleManager._normal_manage_access=DTMLFile('dtml/Zope261/access', globals()
                            , management_view='Security'
                            , body_tab={'label':'Permissions','order':1, 'management_view':'Security', 'url':'manage_access'}
                            )

    RoleManager._method_manage_access=DTMLFile('dtml/Zope261/methodAccess', globals()
                            , management_view='Security'
                            , body_tab={'label':'Permissions','order':1, 'management_view':'Security', 'url':'manage_access'}
                            )


    RoleManager.security=security
    Globals.InitializeClass(RoleManager)
    InitializeBodyTabs(RoleManager)
