# $Header: /usr/custom/cvs/public/EnergyPlusLive/lib/python/Products/ZMIPatch/AccessControl_Owned/__init__.py,v 1.6 2003/12/02 08:44:06 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#


__doc__ = 'Add a Replace tab to Folders'
__version__ = '1.8'


from zLOG import LOG, INFO, BLATHER

LOG('ZMIPatch', BLATHER, 'ZMI Patch:AccessControl.Owner', """Hotfixing: AccessControl.Owner: reindex on take ownership,\n\t\tJohan Carlsson, 2001-10-03, version Easy Publisher 1.8\n""")


import Globals
from Globals import DTMLFile
from AccessControl.Owned import Owned, UnownableOwner
from AccessControl import getSecurityManager
from ComputedAttribute import ComputedAttribute
import urlparse
from Acquisition import aq_base, aq_get, aq_parent
from AccessControl import ClassSecurityInfo

securityOwned = ClassSecurityInfo()

Owned.manage_takeOwnership_orig = Owned.manage_takeOwnership

_mark = None


securityOwned.declareProtected('Take ownership', 'manage_takeOwnership')
def manage_takeOwnership(self, REQUEST, RESPONSE, recursive=0):
    """
    Take ownership (responsibility) for an object. If 'recursive'
    is true, then also take ownership of all sub-objects.
    And reindex the object in the Catalog(s).
    """
    security=getSecurityManager()
    want_referer=REQUEST['URL1']+'/manage_owner'
    got_referer=("%s://%s%s" %
                 urlparse.urlparse(REQUEST['HTTP_REFERER'])[:3])
    __traceback_info__=want_referer, got_referer
    if (want_referer != got_referer or security.calledByExecutable()):
        raise 'Unauthorized', (
            'manage_takeOwnership was called from an invalid context'
            )

    self.changeOwnership(security.getUser(), recursive)

    if hasattr(self,'_reindex_all_owner'):
        self._reindex_all_owner()

    if RESPONSE is not None: RESPONSE.redirect(REQUEST['HTTP_REFERER'])

securityOwned.declareProtected('Take ownership', 'manage_changeOwnershipType')
def manage_changeOwnershipType(self, explicit=1, RESPONSE=None, REQUEST=None):
    """
    Change the type (implicit or explicit) of ownership.
    """
    old=getattr(self, '_owner', None)
    if explicit:
        if old is None:
            owner=aq_get(self, '_owner', None, 1)
            if owner is not None and owner is not UnownableOwner:
                self._owner=owner
    else:
        if old is not None:
            new=aq_get(aq_parent(self), '_owner', None, 1)
            if old is new and (self.__dict__.get('_owner', _mark) is not _mark):
                del self._owner
    if RESPONSE is not None: RESPONSE.redirect(REQUEST['HTTP_REFERER'])


def _reindex_all_owner(self, obj=None):
    if obj is None: obj=self
    if hasattr(aq_base(obj), 'reindexObject'):
        obj.reindexObject()
    if hasattr(aq_base(obj), 'objectValues'):
        for item in obj.objectValues():
            if hasattr(aq_base(item), '_reindex_all_owner') and hasattr(item, '_owner'):
                item._reindex_all_owner()

from App.version_txt import getZopeVersion
zope_version=getZopeVersion()
LOG('ZMIPatch', 0, "RoleManager:zope_version: %s" % '-'.join(map(str, zope_version)) )

if zope_version[0:3]>=(2,7,0) and zope_version[0:3] < (2,8,0):
    securityOwned.declareProtected('View management screens', 'manage_owner')
    manage_owner = DTMLFile('dtml/Zope270/owner', globals())

elif zope_version[0:3]>=(2,6,1) and zope_version[0:3] < (2,7,0):

    securityOwned.declareProtected('View management screens', 'manage_owner')
    manage_owner = DTMLFile('dtml/Zope261/owner', globals())
elif zope_version[0:3]>=(2,5,1) and zope_version[0:3] < (2,6,1):
    securityOwned.declareProtected('View management screens', 'manage_owner')
    manage_owner = DTMLFile('dtml/Zope251/owner', globals())
else:
    securityOwned.declareProtected('View management screens', 'manage_owner')
    manage_owner = DTMLFile('dtml/Zope261/owner', globals())

Owned._reindex_all_owner = _reindex_all_owner
Owned.manage_takeOwnership = manage_takeOwnership
Owned.manage_changeOwnershipType = manage_changeOwnershipType
Owned.manage_owner = manage_owner

def _getauthor(self):
    try:
        user = self.getOwner()
        if user: return user.getId()
        return 'Nobody'
    except:
        return 'Nobody'
author = ComputedAttribute(_getauthor,1)

securityOwned.declareProtected('View', 'author')
Owned.author = author

Owned.securityOwned = securityOwned

Globals.InitializeClass(Owned)

