# $Header: /usr/custom/cvs/public/EnergyPlusLive/lib/python/Products/ZMIPatch/EP/__init__.py,v 1.8 2003/06/11 07:23:44 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

import Globals, os
from Globals import DTMLFile

from App.ImageFile import ImageFile
from App.Management import Navigation
#from Products.EasyEditor.EasyDocument import EasyRoot
from OFS.Application import Application as EasyRoot
from AccessControl import ClassSecurityInfo
from ep_wizard import *


security = ClassSecurityInfo()

Navigation.WizardRegistry = WizardRegistry()
def addObject(wizard):
    setattr(EasyRoot, wizard.id, wizard)
    setattr(EasyRoot, wizard.id+'__roles__', None)
    Navigation.WizardRegistry.addObject(wizard, wizard.disable_attribute)
    return getattr(EasyRoot, wizard.id)




#This attributes are being used in other ZMIPatches (like UpgradeSupport)
EasyRoot.ep_distributor="Colliberty"
EasyRoot.ep_distributor_url="http://www.easypublisher.com"
EasyRoot.ep_product = 'Easy Publisher'
EasyRoot.ep_product_url = 'http://www.easypublisher.com'
EasyRoot.ep_release = '1.8'



extlink=addObject(WizardExternalLink('ep_documentation'
          ,title='Documentation'
          ,short_title='Documentation'
          ,description='Do you need support, check out this page on how to get technical support for Easy Publisher.'
          ,url='http://www.easypublisher.com/documentations'
          ,target='_blank'
          ,icon='icons/ep_documentation.gif'))

extlink=addObject(WizardExternalLink('ep_support_information'
          ,title='Support Information'
          ,short_title='Support'
          ,description='Do you need support, check out this page on how to get technical support for Easy Publisher.'
          ,url='http://www.easypublisher.com/support_information'
          ,target='_blank'
          ,icon='icons/support_information.gif'))

extlink=addObject(WizardExternalLink('ep_contact_us'
          ,title='Contact Information'
          ,short_title='Contact'
          ,description='Here is how you can contact Colliberty and the Easy Publisher Development Team. '
                       'Also see Support Information for technical support.'
          ,url='http://www.easypublisher.com/contact_us'
          ,target='_blank'
          ,icon='icons/contact_us.gif'))

extlink=addObject(WizardExternalLink('ep_mailinglists'
          ,title='Mailing Lists'
          ,short_title='Mailing Lists'
          ,description='Here you will find all mailing list for Easy Publisher.'
          ,url='http://www.easypublisher.com/mailinglists'
          ,target='_blank'
          ,icon='icons/mailinglists.gif'))


EasyRoot.security = security
Globals.InitializeClass(EasyRoot)

manage_wsubmenu = DTMLFile('dtml/manage_wsubmenu', globals())
manage_menu = DTMLFile('dtml/menu', globals())
setattr(Navigation, 'manage_wsubmenu__roles__', None)
setattr(Navigation, 'manage_wsubmenu', manage_wsubmenu)
setattr(Navigation, 'manage_menu__roles__', None)
setattr(Navigation, 'manage_menu', manage_menu)
Globals.InitializeClass(Navigation)


