# $Header: /usr/custom/cvs/public/EnergyPlusLive/lib/python/Products/ZMIPatch/OFS_SimpleItem/__init__.py,v 1.1 2004/01/10 17:54:27 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

__doc__ = """OFS_ObjectManager."""
__version__='$Revision: 1.1 $'[11:-2]

from zLOG import LOG, INFO, BLATHER

from Globals import InitializeClass, DTMLFile
from OFS.SimpleItem import Item
from App.version_txt import getZopeVersion
from AccessControl import ClassSecurityInfo
from Products.EasyCore.EasyCorePermissions import EasyIntrospektManage
from types import *

LOG('ZMIPatch', BLATHER, 'ZMI Patch:OFS.SimpleItem.Item', 'ZMI Patch: OFS SimpleItem.Item: , Adds a manage_vars tab.\n\t\tJohan Carlsson, 2004-01-09, version Easy Publisher 1.8\n')

securityItem = ClassSecurityInfo()
zope_version=getZopeVersion()

_manage_vars = DTMLFile('dtml/263/manage_vars', globals())
Item._manage_vars = _manage_vars

securityItem.declarePrivate('formatValue')
def formatValue(self, value):
    result=value
    type_of_value=type(value)
    if type_of_value in (TupleType, ListType) and value and type(value[0])==DictType:
        result=()
        for item in value:
            result=result+(self.formatValue(item),)
        result="(<br/>%s<br/>)" % (', <br/>'.join(result),)
    elif type_of_value is   DictType:
        result='<table border="0" style="margin:2px 2px 2px 20px;border:0px solid #ccc;">'
        result=result+'<tr><td class="form-label" cellspan="3">{</td></tr>'
        for k,v in value.items():
            result=result+'<tr><td>&nbsp;</td><td class="form-label">%s</td><td class="form-text">%s</td></tr>' % (k,v)
        result=result+'<tr><td class="form-label" cellspan="3">}</td></tr>'
        result=result+"</table>"
    return str(result)

Item.formatValue = formatValue

securityItem.declareProtected(EasyIntrospektManage, 'manage_vars')
def manage_vars(self, REQUEST=None):
    """Introspekt the vars of a particular objects"""
    return Item._manage_vars(self, zope_version=zope_version, ep_version="1.8", vars=vars(self))

Item.manage_vars = manage_vars

InitializeClass(Item)